function [DataN, DataE, DataU, Stot, fid, message] = ReadPBOres(fname)
% ReadPBOres: Function to return PBO residual time series from residual files
% gnerated with tsfot.
%
fid = fopen(fname,'r');
if ( fid == -1 ) 
   message = sprintf('Error: %s not found\n',inp_pos);
   return
end
message = '';

pbo_dot = textread(fname,'%*s %*s %s',1,'headerlines',1);
sta_name = textread(fname,'%*s %*s %*s %s',1,'headerlines',2);
first_epoch = textread(fname,'%*s %*s %*s %d',1,'headerlines',3);
% NEU Reference position :    59.3585312550  206.5391994203  487.21908
[Stot(1) Stot(2) Stot(3)] = textread(fname,'%*s %*s %*s %*s %f %f %f',1,'headerlines',7);
% Now start new format read which has additonal headers.  Count number of
% header line
head = 1; numhead = 0;
while head == 1
    line = fgetl(fid);
    if line(1) == ' ' 
        head = 0;
    else
        numhead = numhead + 1;
    end
end
% Old header numhead = 9;    

[jday,n,err_n,flg_n, e, err_e, flg_e, u,err_u, flg_u] = textread(fname,'%*d %*d %*f %f %*f %*f %*f %f %f %d %f %f %d %f %f %d', ...
    'headerlines',numhead);

% Remove data with non-zero flags
OK = find(flg_n + flg_e + flg_u == 0) ;
jday = jday(OK);  
n=n(OK) ; err_n = err_n(OK);
e=e(OK) ; err_e = err_e(OK);
u=u(OK) ; err_u = err_u(OK);

% Conert jday back to DecYrs.  First convert MJD to MATLAB's serial date
% number
jday = jday + 678942;
% Now covert.  Needs to be done one at a time due to leap years
for i = 1:length(jday);
    bdfull = datevecl(jday(i));
    decyr = DateToYr(bdfull,6);
    jday(i) = decyr;
end
% Now creat the DataN, DataE, DataU arrays
DataN = [jday'; n'; err_n'];
DataE = [jday'; e'; err_e'];
DataU = [jday'; u'; err_u'];

