function xyl = ReadXY(fid)
% xyl = ReadXY(fid): Reads a file open to fid for pairs of lat/long;
% Returns long (0-360) lat pairs with NaN at breaks

xyl = [];
% Assume first line is a header line
done = 0;
h = fgetl(fid);
while ~done
    [xyn, count] = fscanf(fid,'%f');
    if count ~= 0, 
        xyl = [xyl; xyn; NaN; NaN];
    end
    h = fgetl(fid);
    if ~ischar(h), done = 1; end
end
% Now reshape
count = length(xyl); nxy = count/2;
xyl = reshape(xyl,2,nxy);
%
% Add 360 to any negative longitude
ind = [xyl(2,:)<0]; xyl(2,:) = xyl(2,:) + 360*ind;

        
     
    
    