function gpsgui(option,optfh)
% GPSGUI Function to control gui plots
%
% Get the current graphics handles
% Define constants we need

% Define those quanities that we want to be persistent for the duration of
% the GUI operation
%persistent breaks edits Strend Stot outall_save symnum
%
CompName = ['North';'East ';'Up   '];

% Check to see if we got here with a call back (as opposed to a direct call
% to gpsgui
if nargin == 2
    hf = optfh;
else
    hf = gcbf;
end
% Extract the peristent variables from the figure handle
savecom = get(hf,'UserData');
udir = savecom.Udir;
breaks = savecom.Breaks; edits = savecom.Edits; Strend = savecom.Strend;
Stot = savecom.Stot; outall_save = savecom.Outall_save; symnum = savecom.Symnum;
pname = savecom.PName; 
break_code = savecom.Break_code; edit_code = savecom.Edit_code; eqfile = savecom.EqFile;

hu = findobj(hf,'Tag','EqFileHead');
saveeq = get(hu,'UserData');
eqrn = saveeq.EqRn; eqeq = saveeq.EqEq;

sigmahndl = findobj(hf, 'Tag','SigmaCut'); 
sigmacut = str2double(get(sigmahndl,'String'));
outlierhndl = findobj(hf, 'Tag','Outlier');
outlierval = get(outlierhndl,'Value');
outlierlist = get(outlierhndl,'String');  
outliercut = outlierlist(outlierval);
if outliercut == 'a'
   outliercut = '';
else
   outliercut = str2double(outliercut);
end

% Get the Erase button status and reset to off 
he = findobj(hf,'Tag','EdFileErase'); EraseEdFile = get(he,'Value'); set(he,'Value',0);
he = findobj(hf,'Tag','EnFileErase'); EraseEnFile = get(he,'Value'); set(he,'Value',0);
he = findobj(hf,'Tag','RtFileErase'); EraseRtFile = get(he,'Value'); set(he,'Value',0);

% Get the Write status on each file
he = findobj(hf,'Tag','EdFileWrite'); WriteEdFile = get(he,'Value'); 
he = findobj(hf,'Tag','EnFileWrite'); WriteEnFile = get(he,'Value'); 
he = findobj(hf,'Tag','RtFileWrite'); WriteRtFile = get(he,'Value'); 

% Get status of offset on append
he = findobj(hf,'Tag','OffApp'); OffAppend = get(he,'Value'); 
% MOD TAH 150107: Get status of DiffOff: (no offset when diff data read).
he = findobj(hf,'Tag','DiffOff'); DiffOff = get(he,'Value'); 

% Find the status of break saving and appending
hb = findobj(hf,'Tag','RetainBreaks'); RetainBreaks = get(hb,'Value');
ha = findobj(hf,'Tag','AppendBreaks'); AppendBreaks = get(ha,'Value');
hr = findobj(hf,'Tag','ReportEdits'); ReportEdits = get(hr,'Value');

% Find the status of realistic errors and averaging data
he = findobj(hf,'Tag','RealSigma'); RealSigma = get(he,'Value');

% Find the status is a spectral periodogram is to be produced MM 201212:
he = findobj(hf,'Tag','Spectral'); Spectral = get(he,'Value');

% MOD TAH 141203: See if Kalman filter option selected
he = findobj(hf,'Tag','KFilt'); KF = get(he,'Value');
he = findobj(hf,'Tag','DispStoch'); DispStoch = get(he,'Value');
% Get options from KFOPTS button
hz = findobj(gcf,'Tag','KFOPTS') ; 
kfopts = get(hz,'UserData');
kftype = kfopts{1} ; % RW/FOGM/WN
min_rw = eval(kfopts{2});
DispStoch = 0 ; DispRes = 0;
if strcmp(kfopts{5},'Y') , DispStoch = 1; end
if strcmp(kfopts{6},'Y') , DispStoch = 1; DispRes = 1; end
if ~isempty(kfopts{3}) 
    try
        RWu = ones(3,1).*sscanf(kfopts{3},'%f'); 
    catch
        fprintf('Error reading RW noise %s Using default; FIX \n',kfopts{3});
        RWu = zeros(3,1);
    end
end
if ~isempty(kfopts{4})
    try
        taufu = ones(3,1).*sscanf(kfopts{4},'%f'); 
    catch
        fprintf('Error reading taus %s Using default; FIX \n',kfopts{4});
        taufu = ones(3,1);
    end   
end

% MOD TAH 090312: Added feature to allow date to be included in the
% Averaging length (so that averages will not cross a major earthquake
% event).  Format is AvgLenrth YY MM DD
he = findobj(hf,'Tag','AvgLength'); %AvgLength = str2double(get(he,'String'));
% See what is in the String element
avstr = get(he,'String');
vals = sscanf(avstr,'%f');
AvgLength = vals(1); AvgTime = 0; % Usual value
vl = length(vals);
if vl >= 4
    AvgTime = DateToYr(vals(2:vl),length(vl)-1);
end

% See if we need to update the list of breaks that can be deleted
hbhndl = findobj(hf,'Tag','DeleteBreak');
UpdateBreakGUI(hbhndl, breaks);
h = [0 0 0];
for i = 1:3
    % For reasons that are not clear, the code below needs to reset the
    % Axis[1-3] entries under Tag when ever results are plotted (see Load,
    % Append)
     h(i) = findobj(hf, 'Tag',strcat('Axis',num2str(i,'%1d')));
     set(h(i),'NextPlot','add');
end

% Get Site info
sitehndl = findobj(hf, 'Tag','ListboxSites');
siten = get(sitehndl,'Value');
sites = get(sitehndl,'UserData');
if ~isempty(sites), name = sites(siten,:);
else name = '';end

%
% Generate the file name
if isempty(udir)
    if length(name) == 8
        fname = [strcat('mb_',name,'.dat1'); strcat('mb_',name,'.dat2'); strcat('mb_',name,'.dat3')];
    elseif ~isempty(name) 
        fname = strcat(name,'.pos'); % MOD TAH 090330: Removed _frame
        ftype = 1 ;  % Denotes .pos file
        if exist(fname,'file') ~= 2
           % Try .res version.
           iend = strfind(name,' ') ; iend = iend(1);
           if iend < 1 ; iend = length(name)+1 ; end
           fname = strcat(name(1:iend-1),'.res'); % MOD TAH 090330: Removed _frame
           ftype = 2 ;  % Denotes .res file
        end
    end
else
    if length(name) == 8
        fname = [strcat(udir,'/mb_',name,'.dat1'); ...  % Add the extra / before mb incase not there
                strcat(udir,'/mb_',name,'.dat2'); ...
                strcat(udir,'/mb_',name,'.dat3')];
    elseif ~isempty(name)
        fname = strcat(udir,'/',name,'.pos'); % MOD TAH 090330: Removed _frame
        ftype = 1 ;  % Denotes .pos file
        if exist(fname,'file') ~= 2
           % Try .res version.
           iend = strfind(name,' ') ;
           if iend < 1 ; iend = length(name)+1 ; end
           fname = strcat(udir,'/',name(1:iend-1),'.res'); % MOD TAH 090330: Removed _frame
           ftype = 2 ;  % Denotes .res file
        end
    end
end
   

switch(option)
    case 'Dir' ;
        % See if we can find the current site being plotted
        hs = findobj(hf,'Tag','ListboxSites');
        sites = get(hs,'String'); selsite = get(hs,'Value');
        % Check that we have an existing set of sites to check to get the
        % name of the site currently ploted
        if ~isempty(sites)
            if selsite > 0 && selsite < length(sites(:,1))
                oldsite = sites(selsite,:);
            else
                oldsite = []; 
            end
        else
            oldsite = [];
        end
        
        % Get the new directory name form the DirName handle
        hd = findobj(hf,'Tag','DirName');
        udir = get(hd,'String');
        sites = GetSites(udir);
        % Now see if we can find the same site in the newlist
        if ~isempty(oldsite) 
            selsite = 0;
            for i = 1:length(sites(:,1))
                if sites(i,1:8) == oldsite(1:8) & selsite == 0 , selsite = i ; end
            end
            if selsite == 0
                for i = 1:length(sites(:,1))
                    if sites(i,1:4) == oldsite(1:4) & selsite == 0 , selsite = i ; end
                end
                if selsite ~= 0
                    fprintf(1,'Match found to %s\n',sites(selsite,:));
                else
                    fprintf(1,'No 4-character match found\n');
                    selsite = 1;  % Just select the first site
                end
            end
        else
            selsite = 1;
        end
        % Now save the sites back into the list box
        hs = findobj(hf,'Tag','ListboxSites');
        set(hs,'String',sites,'Value',selsite,'UserData',sites);
        
    case 'Search'
        % Find this search string
        hs = findobj(hf,'Tag','Searchvalue');
        searchsite = get(hs,'String');
        if ~isempty(searchsite)
            for k = 1:length(sites(:,1))
                indx = strfind(sites(k,:),searchsite);
                if indx == 1
                   hl = findobj(hf,'Tag','ListboxSites');
                   set(hl,'Value',k);
                   break
                end
            end
        end

	
    case 'Load'  ;
       clear DataN DataE DataU sym
       symnum = 1;
        % Initialize the Breaks and Edit values
        if RetainBreaks == 0
           breaks = Initbe;
           break_code = Initbrkcod;
        end
        edits = Initedits;
        edit_code = Initedtcod;
        
% MOD TAH 060113: If *pos files are being used, read these files first. 
        if size(fname,1) == 1
            % This is new format file
            if ftype == 1 
               [DataN, DataE, DataU, Stot, fid, message] = ReadPBOts(fname);
            else
               [DataN, DataE, DataU, Stot, fid, message] = ReadPBOres(fname);
            end
            symN = repmat(1,1,size(DataN,2));symE = repmat(1,1,size(DataE,2));
            symU = repmat(1,1,size(DataU,2));
            if fid == -1
                disp(['Error opening ' fname ' : ' message])
                 ok = 0;
                 return
            end
        else
            % Read the mb_files.  Do this all at onve
            Sval = zeros(3,1);
            for i = 1:3
                [fid, message] = fopen(fname(i,:),'r');
                if fid == -1
                  disp(['Error opening ' fname(i,:) ' : ' message])
                  ok = 0;
                  return
                end    
                % Now we will try to read the file.  These
                % files have three header lines and then data
                %
                % Read the header lines
                H1 = fgetl(fid);
                H2 = fgetl(fid);
                ival = str2double(H2(28:length(H2)-1));
                % Stot(i) = ival-mod(ival,10);
                Sval(i) = ival;  % Save the total values, below we convert to lat, long and ht.
                H3 = fgetl(fid);
                % The rest of the file is numeric with three values per lines and we
                % can read all at once
                [rData,tot] = fscanf(fid,' %f %f %f');
                % Close the data file at this point
                fclose(fid); 
                % Now reshape the Data into 3:tot/3 array
                num = tot/3;
                rData = reshape(rData,3,num);
                if i == 1
                    DataN = rData; symN = repmat(1,1,num);
                    DataN(2:3,:) = DataN(2:3,:)*1000 ; % Convert to mm
                elseif i == 2
                    DataE = rData; symE = repmat(1,1,num);
                    DataE(2:3,:) = DataE(2:3,:)*1000 ; % Convert to mm
                elseif i ==3
                    DataU = rData; symU = repmat(1,1,num);
                    DataU(2:3,:) = DataU(2:3,:)*1000 ; % Convert to mm
                end
            end
            Stot = NEU_to_GEOD(Sval);
        end
%       Finished reading either the mb_ or the *pos file.
%       See if there are edits or breaks due to earthquakes or renames from
%       and eq_file
        [edits breaks edit_code break_code ] = EqEdit(edits, edit_code, breaks, break_code, name, Stot, eqeq, eqrn, DataN(1,:),symnum,symN);
%       Now plot
        pname = name;
        for i = 1:3
          if i == 1
              hp = gpsplot(h(i),DataN,[],edits,symN,sigmacut,outliercut,0,i);
              set(hp,'Tag','PlottedDataN');
              set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
              set(h(i),'UserData',{DataN,symN});              
              Comptext = CompName(i,:);
              PlotTitle = sprintf('Data %s %s',pname,Comptext);
              title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
          elseif i == 2 
              hp = gpsplot(h(i),DataE,[],edits,symE,sigmacut,outliercut,0,i);
              set(hp,'Tag','PlottedDataE');
              set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
              set(h(i),'UserData',{DataE,symE});
              Comptext = CompName(i,:);
              PlotTitle = sprintf('Data %s %s',pname,Comptext);
%              title(PlotTitle);
              title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');

          elseif i == 3
              hp = gpsplot(h(i),DataU,[],edits,symU,sigmacut,outliercut,0,i);
              set(hp,'Tag','PlottedDataU');
              set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
              set(h(i),'UserData',{DataU,symU});
              Comptext = CompName(i,:);
              PlotTitle = sprintf('Data %s %s',pname,Comptext);
              title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');

          end
      %   Show where the breaks are on the plot 
      %   breaks = get(gcbo,'UserData');
          if isempty(breaks), lbrk = 0; else lbrk = length(breaks(:,1)); end  
          for k = 1:lbrk
               x = breaks(k,1); te = breaks(k,2);
               if te == 0 && breaks(k,6) == 0  
                   plot([x x],ylim,'g');
               elseif te == 0 && breaks(k,6) == 3 
                   plot([x x],ylim,'k');
               elseif te > x
                   plot([x x],ylim,'b'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x te],[yb yb],'b','LineWidth',2);
               else plot([x x],ylim,'r'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x x-te],[yb yb],'r','LineWidth',2);
               end
          end
        end
          
    case 'Append' 
        gn = get(h(1),'UserData'); DataN = gn{1}; symN=gn{2};
        ge = get(h(2),'UserData'); DataE = ge{1}; symE=ge{2};
        gu = get(h(3),'UserData'); DataU = gu{1}; symU=gu{2};
        if AppendBreaks
            breaks = [breaks; max(DataN(1,:))+0.5/365 0 0 0 0 0];
            break_code = [break_code; 7];
        end 
        [breaks break_code] = checkbr(breaks, break_code);
        symnum = mod(symnum,5)+1;
%       Based on the mb_ or .pos file, read the new input
        if size(fname,1) == 1
            % This is new format file
            if ftype == 1 
               [NewN, NewE, NewU, SNew, fid, message] = ReadPBOts(fname);
            else
               [NewN, NewE, NewU, SNew, fid, message] = ReadPBOres(fname);
            end

            % Now adjust for any difference in the initial coordiates
            dNEU = [(Stot(1)-SNew(1))*pi/180*6378153; ...
                    (Stot(2)-SNew(2))*pi/180*cos(SNew(1)*pi/180)*6378153; ...
                    (Stot(3)-SNew(3))] * 1000 ;
            % MOD TAH 150107: Do not align if differenced files because the 
            %     Reference positions are somewhat arbitary
            if DiffOff , dNEU = zeros(3,1); end
            % Only align if sites are with 3 meters
            if dNEU'*dNEU < 1.e6 
                fprintf('Aligning %s dNEU %6.1f %6.1f %6.1f mm\n',name,dNEU)
                NewN(2,:) = NewN(2,:)-dNEU(1);
                NewE(2,:) = NewE(2,:)-dNEU(2);
                NewU(2,:) = NewU(2,:)-dNEU(3);
            else
                Stot = SNew ;  % Save the new reference position
            end
            
            symr = repmat(symnum,1,size(NewN,2));
            [DataN,symN] = GPSMerge(DataN, symN, NewN, symr, name, 1, OffAppend);
            [DataE,symE] = GPSMerge(DataE, symE, NewE, symr, name, 2, OffAppend);
            [DataU,symU] = GPSMerge(DataU, symU, NewU, symr, name, 3, OffAppend);
            if fid == -1
                disp(['Error opening ' fname ' : ' message])
                 ok = 0;
                 return
            end
        else

            for i = 1:3
                [fid, message] = fopen(fname(i,:),'r');
                if fid == -1
                    disp(['Error appending ' fname(i,:) ' : ' message])
                    ok = 0;
                    return
                end    
        %       Now we will try to read the file.  These
        %       files have three header lines and then data
        %
        %       Read the header lines
                H1 = fgetl(fid);
                H2 = fgetl(fid);
                H3 = fgetl(fid);
        %       The rest of the file is numeric with three values per lines and we
        %       can read all at once
                [rData,tot] = fscanf(fid,' %f %f %f');
        %       Close the data file at this point
                fclose(fid);
        %       Now reshape the Data into 3:tot/3 array
                num = tot/3;
                rData = reshape(rData,3,num);
                symr = repmat(symnum,1,num);
                if i == 1
                    rData(2:3,:) = rData(2:3,:)*1000 ; % Convert to mm
                    [DataN,symN] = GPSMerge(DataN, symN, rData, symr, name, 1, OffAppend);
                elseif i == 2 
                    rData(2:3,:) = rData(2:3,:)*1000 ; % Convert to mm
                    [DataE,symE]  = GPSMerge(DataE, symE, rData, symr, name, 2, OffAppend);
                elseif i ==3
                    rData(2:3,:) = rData(2:3,:)*1000 ; % Convert to mm
                    [DataU,symU] = GPSMerge(DataU, symU, rData, symr, name, 3, OffAppend);
                end
                
            end
        end
%       Finished reading either the mb_ or the *pos file.
%       See if there are edits or breaks due to earthquakes or renames from
%       and eq_file
%        [edits breaks] = EqEdit(edits, breaks, name, Stot, eqeq, eqrn, DataN(1,:),symnum,symN);
        [edits breaks edit_code break_code ] = EqEdit(edits, edit_code, breaks, break_code, name, Stot, eqeq, eqrn, DataN(1,:),symnum,symN);
%       Now plot the result
        pname = strcat(pname,'+',name);
        for i = 1:3
            
           if i == 1
               hp = gpsplot(h(i),DataN,[],edits,symN,sigmacut,outliercut,0,i);
               set(hp','Tag','PlottedDataN');
               set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
               set(h(i),'UserData',{DataN,symN});
               Comptext = CompName(i,:);
               PlotTitle = sprintf('Append %s %s',pname,Comptext);
               title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
           elseif i == 2 
               hp = gpsplot(h(i),DataE,[],edits,symE,sigmacut,outliercut,0,i);
               set(hp','Tag','PlottedDataE');
               set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
               set(h(i),'UserData',{DataE,symE});
               Comptext = CompName(i,:);
               PlotTitle = sprintf('Append %s %s',pname,Comptext);
               title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
           elseif i == 3
               hp = gpsplot(h(i),DataU,[], edits,symU,sigmacut,outliercut,0,i);
               set(hp','Tag','PlottedDataU');
               set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
               set(h(i),'UserData',{DataU,symU});
               Comptext = CompName(i,:);
               PlotTitle = sprintf('Append %s %s',pname,Comptext);
               title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
           end
           %   Show where the breaks are on the plot 
           if isempty(breaks), lbrk = 0; else lbrk = length(breaks(:,1)); end  
           for k = 1:lbrk
               x = breaks(k,1); te = breaks(k,2);
               if te == 0 && breaks(k,6) == 0  
                   plot([x x],ylim,'g');
               elseif te == 0 && breaks(k,6) == 3  
                   plot([x x],ylim,'k');
               elseif te > x
                   plot([x x],ylim,'b'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x te],[yb yb],'b','LineWidth',2);
               else plot([x x],ylim,'r'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x x-te],[yb yb],'r','LineWidth',2);
               end
           end
       
        end   % For loop over i (each component)
        
% MOD TAH 060125: Added Difference option        
    case 'Difference' 
        gn = get(h(1),'UserData'); DataN = gn{1}; symN=gn{2};
        ge = get(h(2),'UserData'); DataE = ge{1}; symE=ge{2};
        gu = get(h(3),'UserData'); DataU = gu{1}; symU=gu{2};
%       Based on the mb_ or .pos file, read the new input
        if size(fname,1) == 1
            % This is new format file
            if ftype == 1 
               [NewN, NewE, NewU, SNew, fid, message] = ReadPBOts(fname);
            else
               [NewN, NewE, NewU, SNew, fid, message] = ReadPBOres(fname);
            end
            % Now adjust for any difference in the initial coordiates
            dNEU = [(Stot(1)-SNew(1))*pi/180*6378153; ...
                    (Stot(2)-SNew(2))*pi/180*cos(SNew(1)*pi/180)*6378153; ...
                    (Stot(3)-SNew(3))] * 1000 ;
            % Only align if sites are with 3 meters
            if dNEU'*dNEU < 1.e6 
                fprintf('Aligning %s dNEU %6.1f %6.1f %6.1f mm\n',name,dNEU)
                NewN(2,:) = NewN(2,:)-dNEU(1);
                NewE(2,:) = NewE(2,:)-dNEU(2);
                NewU(2,:) = NewU(2,:)-dNEU(3);
            end
            
            symr = repmat(symnum,1,size(NewN,2));
            [DataN,symN] = GPSDiff(DataN, symN, NewN, 1);
            [DataE,symE] = GPSDiff(DataE, symE, NewE, 2);
            [DataU,symU] = GPSDiff(DataU, symU, NewU, 3);
            fprintf('Mean NEU Differences for %s %6.2f %6.2f %6.2f mm\n',name, ...
                  mean(DataN(2,:)),mean(DataE(2,:)),mean(DataU(2,:)))
            if fid == -1
                disp(['Error opening ' fname ' : ' message])
                 ok = 0;
                 return
            end
        else

            for i = 1:3
                [fid, message] = fopen(fname(i,:),'r');
                if fid == -1
                    disp(['Error appending ' fname(i,:) ' : ' message])
                    ok = 0;
                    return
                end    
        %       Now we will try to read the file.  These
        %       files have three header lines and then data
        %
        %       Read the header lines
                H1 = fgetl(fid);
                H2 = fgetl(fid);
                H3 = fgetl(fid);
        %       The rest of the file is numeric with three values per lines and we
        %       can read all at once
                [rData,tot] = fscanf(fid,' %f %f %f');
        %       Close the data file at this point
                fclose(fid);
        %       Now reshape the Data into 3:tot/3 array
                num = tot/3;
                rData = reshape(rData,3,num);
                symr = repmat(symnum,1,num);
                if i == 1
                    rData(2:3,:) = rData(2:3,:)*1000 ; % Convert to mm
                    [DataN,symN] = GPSDiff(DataN, symN, rData, 1);
                elseif i == 2 
                    rData(2:3,:) = rData(2:3,:)*1000 ; % Convert to mm
                    [DataE,symE] = GPSDiff(DataE, symE, rData, 2);
                elseif i ==3
                    rData(2:3,:) = rData(2:3,:)*1000 ; % Convert to mm
                    [DataU,symU] = GPSDiff(DataU, symU, rData, 3);
                end
                fprintf('Mean NEU Differences for %s %6.2f %6.2f %6.2f mm\n',name, ...
                     mean(DataN(2,:)),mean(DataE(2,:)),mean(DataU(2,:)))
                
            end
        end
        % See if we have data:
        if isempty(DataN) 
            fprintf('No overlapping data found for site %s\n',name)
            delete(get(h(1),'Children'));
            delete(get(h(2),'Children'));
            delete(get(h(3),'Children'));
            
            return
        end
%       Finished reading either the mb_ or the *pos file.
%       See if there are edits or breaks due to earthquakes or renames from
%       and eq_file
%        [edits breaks] = EqEdit(edits, breaks, name, Stot, eqeq, eqrn, DataN(1,:),symnum,symN);
        [edits breaks edit_code break_code ] = EqEdit(edits, edit_code, breaks, break_code, name, Stot, eqeq, eqrn, DataN(1,:),symnum,symN);
%       Now plot the result
        pname = strcat(pname,'-',name);
        for i = 1:3
            
           if i == 1
               hp = gpsplot(h(i),DataN,[],edits,symN,sigmacut,outliercut,1000,i);
               set(hp','Tag','PlottedDataN');
               set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
               set(h(i),'UserData',{DataN,symN});
               Comptext = CompName(i,:);
               PlotTitle = sprintf('Diff %s %s',pname,Comptext);
               title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
           elseif i == 2 
               hp = gpsplot(h(i),DataE,[],edits,symE,sigmacut,outliercut,1000,i);
               set(hp','Tag','PlottedDataE');
               set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
               set(h(i),'UserData',{DataE,symE});
               ylabel('Position (mm)');
               Comptext = CompName(i,:);
               PlotTitle = sprintf('Diff %s %s',pname,Comptext);
               title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
           elseif i == 3
               hp = gpsplot(h(i),DataU,[], edits,symU,sigmacut,outliercut,1000,i);
               set(hp','Tag','PlottedDataU');
               set(h(i),'Tag',strcat('Axis',num2str(i,'%1d')));
               set(h(i),'UserData',{DataU,symU});
               ylabel('Position (mm)');
               Comptext = CompName(i,:);
               PlotTitle = sprintf('Diff %s %s',pname,Comptext);
               title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
           end
           %   Show where the breaks are on the plot 
           if isempty(breaks), lbrk = 0; else lbrk = length(breaks(:,1)); end  
           for k = 1:lbrk
               x = breaks(k,1); te = breaks(k,2);
               if te == 0 && breaks(k,6) == 0  
                   plot([x x],ylim,'g');
               elseif te == 0 && breaks(k,6) == 3  
                   plot([x x],ylim,'k');
               elseif te > x
                   plot([x x],ylim,'b'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x te],[yb yb],'b','LineWidth',2);
               else plot([x x],ylim,'r'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x x-te],[yb yb],'r','LineWidth',2);
               end
           end
       
        end   % For loop over i (each component)
        
        
        
    case 'Break'
%       Get the times at which we should add breaks in the
%       times series 
        %breaks = get(gcbo,'UserData');
        button = 3;
        while button == 3;
            [x, y, button] = ginput(1);
            breaks = [breaks; x 0 0 0 0 0];
            plot([x x],ylim,'m');
            break_code = [break_code; 4];
        end
        
    case 'Exponent'
        % Use a click and drag method the get the time and interval
        k = waitforbuttonpress;
        point1 = get(gca,'CurrentPoint');    % button down detected
        finalRect = rbbox;                   % return Figure units
        point2 = get(gca,'CurrentPoint');    % button up detected
        ts = point1(1,1); te = point2(1,1);
        breaks = [breaks; ts te 0 0 0 1];
        break_code = [break_code; 5];
        % Show the Exponent on the plot
        ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
        plot([ts ts],ym,'b'); 
        plot([ts te],[yb yb],'b','LineWidth',2);
        
    case 'Log'
        % Use a click and drag method the get the time and interval
        k = waitforbuttonpress;
        point1 = get(gca,'CurrentPoint');    % button down detected
        finalRect = rbbox;                   % return Figure units
        point2 = get(gca,'CurrentPoint');    % button up detected
        ts = point1(1,1); te = point2(1,1);
        dtl = abs(te-ts);
        breaks = [breaks; ts dtl 0 0 0 2];
        break_code = [break_code; 6];
        % Show the Exponent on the plot
        ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
        plot([ts ts],ym,'r'); 
        plot([ts ts-dtl],[yb yb],'r','LineWidth',2);
        
        
    case 'EditBreak'
        % Set up a inputdlg box to edit the breaks
        breaks = EditBreaks(breaks);
     
        
    case 'Zoom'
        % Get the current state of the button flip
        % zoomstatus = get(gcbo,'Value');
%         if zoomstatus == 1 
%            zoom on;
%         else
%            zoom off;
%         end

        k = waitforbuttonpress;
        point1 = get(gca,'CurrentPoint');    % button down detected
        finalRect = rbbox;                   % return Figure units
        point2 = get(gca,'CurrentPoint');    % button up detected
        tag = get(gca,'Tag');                % Tells us which axes
        xmn = min(point1(1,1),point2(1,1)); xmx = max(point1(1,1),point2(1,1));
        ymn = min(point1(1,2),point2(1,2)); ymx = max(point1(1,2),point2(1,2));
               
        xlim([xmn xmx]); ylim([ymn ymx]);
        % Code not needed anymore
%         % Now reset the size of tips on the error bars
%         ha = findobj(gcf,'Tag','Axis1');
%         he = findobj(ha,'Type','hggroup');
%         hh = get(he,'Children');
%         x = get(hh(2),'Xdata');
%         w = (xmx-xmn)/100;      % Make caps 1% of width
%         x(4:9:end) = x(1:9:end)-w/2;	% Change xdata with respect to ratio
%         x(7:9:end) = x(1:9:end)-w/2;
%         x(5:9:end) = x(1:9:end)+w/2;
%         x(8:9:end) = x(1:9:end)+w/2;
%         set(hh(2),'Xdata',x(:))	% Change error bars on the figure
%         % Now set the other axes
%         ha = findobj(gcf,'Tag','Axis2');
%         he = findobj(ha,'Type','hggroup');
%         hh = get(he,'Children');
%         set(hh(2),'Xdata',x(:))	% Axes are linked so we can just 
%         ha = findobj(gcf,'Tag','Axis3');
%         he = findobj(ha,'Type','hggroup');
%         hh = get(he,'Children');
%         set(hh(2),'Xdata',x(:))	% Axes are linked so we can just set
        
%%
    case 'Edit'
        gn = get(h(1),'UserData'); DataN = gn{1}; symN=gn{2};
        ge = get(h(2),'UserData'); DataE = ge{1}; symE=ge{2};
        gu = get(h(3),'UserData'); DataU = gu{1}; symN=gu{2};

        hn = findobj(gcbf, 'Tag','PlottedDataN');
        he = findobj(gcbf, 'Tag','PlottedDataE');
        hu = findobj(gcbf, 'Tag','PlottedDataU'); 
%       Get the data actually plotted on the screen        
        xdataN = get(hn,'Xdata') ;
        ydataN = get(hn,'Ydata') ;        
        ysizeN = get(h(1),'YLim') ;
        ytolN = abs(ysizeN(2)-ysizeN(1))/100;
        xdataE = get(he,'Xdata') ;
        ydataE = get(he,'Ydata') ;        
        ysizeE = get(h(2),'YLim') ;
        ytolE = abs(ysizeE(2)-ysizeE(1))/100;
        xdataU = get(hu,'Xdata') ;
        ydataU = get(hu,'Ydata') ;        
        ysizeU = get(h(3),'YLim'); 
        ytolU = abs(ysizeU(2)-ysizeU(1))/100;

        xsize = xlim;
        xtol = abs(xsize(2)-xsize(1))/300;

        button = 3;
        of = [0,0];
        while button == 3;
            [x, y, button] = ginput(1);  
            hc = gca;
            ax = get(hc,'Tag');
            % tmp = edits
            if strcmp(ax,'Axis1')
                [edits,plted] = gpsedit(xdataN,ydataN,DataN, x, y, of, xtol, ytolN, edits); edtimes = xdataN(plted);
            end
            if strcmp(ax,'Axis2') 
                [edits,plted] = gpsedit(xdataE,ydataE,DataE, x, y, of, xtol, ytolE, edits); edtimes = xdataE(plted);
            end
            if strcmp(ax,'Axis3') 
                [edits,plted] = gpsedit(xdataU,ydataU,DataU, x, y, of, xtol, ytolU, edits); edtimes = xdataU(plted);
            end
            
            % Now get the points that have been edited based on the
            % times
            axes(h(1)); set(h(1),'NextPlot','add');
            [xed,yed] = gpsgeted(xdataN,ydataN,edtimes);
            plot(xed,yed,'kx','MarkerSize',10);  
            axes(h(2)); set(h(2),'NextPlot','add');
            [xed,yed] = gpsgeted(xdataE,ydataE,edtimes);
            plot(xed,yed,'kx','MarkerSize',10);  
            axes(h(3)); set(h(3),'NextPlot','add');   % Sometimes h(3) goes to replace instead of add.
            [xed,yed] = gpsgeted(xdataU,ydataU,edtimes);
            plot(xed,yed,'kx','MarkerSize',10);  
            % tmp = edits
%            drawnow;
        end        % end loop on while button 3         

        for i = 1:length(edits)
          if isempty(edit_code) || ~any(edit_code(:,1) == edits(i))
             edit_code = [edit_code; edits(i) 5] ;
          end
        end            

    case 'BlockEdit'
        zoom off;        % Turn off zoom in case it is on
        gn = get(h(1),'UserData'); DataN = gn{1}; symN=gn{2};
        ge = get(h(2),'UserData'); DataE = ge{1}; symE=ge{2};
        gu = get(h(3),'UserData'); DataU = gu{1}; symN=gu{2};
        
%       Get the data actually plotted on the screen
        hn = findobj(gcbf, 'Tag','PlottedDataN');
        he = findobj(gcbf, 'Tag','PlottedDataE');
        hu = findobj(gcbf, 'Tag','PlottedDataU'); 
%       Get the data actually plotted on the screen        
        xdataN = get(hn,'Xdata') ;
        ydataN = get(hn,'Ydata') ;        
        xdataE = get(he,'Xdata') ;
        ydataE = get(he,'Ydata') ;        
        xdataU = get(hu,'Xdata') ;
        ydataU = get(hu,'Ydata') ;   
        
        xsize = xlim;
        xtol = abs(xsize(2)-xsize(1))/500;
               
%       Wait until user presses the mouse button
        k = waitforbuttonpress;
        point1 = get(gca,'CurrentPoint');    % button down detected
        finalRect = rbbox;                   % return Figure units
        point2 = get(gca,'CurrentPoint');    % button up detected
        point1 = point1(1,1:2);              % extract x and y
        point2 = point2(1,1:2);
        p1 = min(point1,point2);             % calculate locations
        of = abs(point1-point2);             % and dimensions

        ax = get(gca,'Tag');
        if strcmp(ax,'Axis1') 
            [edits,plted] = gpsedit(xdataN,ydataN,DataN, p1(1), p1(2), of, xtol, 0,  edits); 
            edtimes = xdataN(plted);
        end
        if strcmp(ax,'Axis2') 
            [edits,plted] = gpsedit(xdataE,ydataE,DataE, p1(1), p1(2), of, xtol, 0, edits); 
            edtimes = xdataE(plted);
        end
        if strcmp(ax,'Axis3') 
            [edits,plted] = gpsedit(xdataU,ydataU,DataU, p1(1), p1(2), of, xtol, 0, edits); 
            edtimes = xdataU(plted);
        end
        
        for i = 1:length(edits)
          if isempty(edit_code) || ~any(edit_code(:,1) == edits(i))
             edit_code = [edit_code; edits(i) 1];
          end
        end            
%       Now that we have the list of edits, we need to mark them on the plot           

        axes(h(1)); set(h(1),'NextPlot','add');
        [xed,yed] = gpsgeted(xdataN,ydataN,edtimes);
        plot(xed,yed,'kx','MarkerSize',10);  
        axes(h(2)); set(h(2),'NextPlot','add');
        [xed,yed] = gpsgeted(xdataE,ydataE,edtimes);
        plot(xed,yed,'kx','MarkerSize',10);  
        axes(h(3)); set(h(3),'NextPlot','add');
        [xed,yed] = gpsgeted(xdataU,ydataU,edtimes);
        plot(xed,yed,'kx','MarkerSize',10);  

        drawnow;
        
    case 'Detrend'
%        tmp2 = edits
%        tmpx = edit_code
        % Find the Callback object and get the coefficients to be estimated
        [hd, hgf] = gcbo ;
        % Get selection: 1 -- linear, 2 +annual, 3 +semiannual
        lores = get(findobj(hf,'Tag','LORes'),'Value');
        anpar = get(findobj(hf,'Tag','Annual'),'Value');
        sapar = get(findobj(hf,'Tag','Semiannual'),'Value');
        exprt = get(findobj(hf,'Tag','ExpRates'),'Value');
        spandetrend = get(findobj(hf,'Tag','SpanDetrend'),'Value');
        spansig = 10000.0 ; % Add 10-meter span detrend
        
        % Get parameter number indicator (value used to select parameters)
%        breaks = checkbr(breaks);
        [breaks break_code] = checkbr(breaks,break_code);
        [np, ores] = NumPar(anpar,sapar,exprt,lores,breaks);
        
        %if sapar == 1 , pars = 3; 
        %elseif anpar == 1 , pars = 2;
        %else pars = 1; end
        
%       Get the full data set        
        gn = get(h(1),'UserData'); DataN = gn{1}; symN=gn{2};
        ge = get(h(2),'UserData'); DataE = ge{1}; symE=ge{2};
        gu = get(h(3),'UserData'); DataU = gu{1}; symU=gu{2};
        fprintf(1,'\n----------------------------------------------\n')
        
        for i = 1:length(DataN(1,:))
           if (DataN(3,i) > sigmacut) 
               edits = [edits, i];
           end
        end
        edits = unique(edits); 
        for i = 1:length(DataE(1,:))
           if (DataE(3,i) > sigmacut) 
              edits = [edits, i];
           end
        end
        edits = unique(edits); 
        for i = 1:length(DataU(1,:))
           if (DataU(3,i) > sigmacut) 
              edits = [edits, i];
           end
        end
        edits = unique(edits);
        
        for i = 1:length(edits)
          if isempty(edit_code) || ~any(edit_code(:,1) == edits(i))
             edit_code = [edit_code; edits(i) 3];
          end
        end

%        for i = 1:length(edits)
%          edit_code = [edit_code; edits(i) 1]
%        end
        
        outall = [];            
        Strend = zeros(3,11);
        tauf = ones(3,1);
        dchi = ones(3,1); % scaling for white noise sigmas

 %      Now start the iteration on the estimation 
 %      (iteration needed for editing the outlier data)
 
 %      Loop over each component
        for k = 1:3
           iter = 1; cnt = 0;
           while iter == 1
              cnt = cnt + 1 ;
              if k == 1,     Data = DataN; sym = symN;
              elseif k == 2, Data = DataE; sym = symE;
              elseif k == 3, Data = DataU; sym = symU;
              end

%             Data = get(gcbf,'UserData');
              eds = ones(1,length(Data(1,:)));
              eds = logical(eds);
              for i = 1:length(edits)
                  eds(edits(i)) = 0;
              end
          
              Data = Data(:,eds); sym = sym(:,eds);
              
              % MOD TAH 141221: See if only spanned to be used (downweight
              % outside data)
              if spandetrend
                  if k == 1 ,
                      % Get the times of the first and last data point
                      % (only do this for first since the data will be
                      % replotted after k==1
                      h1 = get(gca,'children'); 
                      xp = get(h1(end),'Xdata'); xrange = [xp(1) xp(end)];
                      % xrange = get(h(k),'Xlim'); 
                  end
                  downind = find( Data(1,:) < xrange(1) | Data(1,:) > xrange(2));
                  Data(3,downind)= Data(3,downind) + spansig ;
              end
                  

%             Form the partial derivatives for the estimation
%             Dimension first (for speed).  Parameters are:
%             1    -- Offset at MeanT
%             2    -- Linear rate (m/yr)
%             3-4  -- Maybe annual;
%             5-6  -- Maybe semiannual;
%             3-np -- Values of the offsets at the break times and
%             exponentials
              meanT = (Data(1,1)+Data(1,end))/2;
              a = zeros(length(Data(1,:)),np);
              for i = 1:length(Data(1,:))
                  p = GenPar(Data(1,i),meanT, np, anpar,sapar,exprt,breaks);
                  a(i,:) = p;
              end 

%             add weight to a
              clear atw w
              sumw = 0;
              w = 1./Data(3,:).^2;
              for i = 1:np
                  atw(:,i) = a(:,i).*w';
              end
              atw = atw';
              sumw = sum(w);

%             Do the Least squares solution.  From pre-fit
%             Normal equations and solve.  Compute statistics
%             from the residuals to the fit.
              neq = atw*a ;
%             In case we have breaks that can not be determined
%             add a small apriori sigma to the diagonal for the
%             for the break estimates
              for i = 3:np
                  if neq(i,i) ~= 0
                     neq(i,i) = neq(i,i)*(1+1.e-6);
                  else
                     neq(i,i) = 1;
                  end 
              end

              if  ~isempty(breaks) && breaks(1,3) ~= 0 
                  neq(2,2) = 1.e10;
                  if k == 1 , AprV = breaks(1,3);
                  elseif k == 2 , AprV = breaks(1,4);
                  elseif k == 3 , AprV = breaks(1,5);
                  end
              else
                  AprV = 0 ;
              end
              bvec = atw*(Data(2,:)-AprV*(Data(1,:)-meanT))';

              soln = inv(neq)*bvec ; soln(2) = soln(2)+AprV;
              
              % First compute the actual residual to get chi**2 and then the 
              % residual for plotting      
              res = (Data(2,:) - (a*soln)');
              
              % MOD TAH 141221: If spanned data only used: Remove additional
              % sigma
              if spandetrend 
                  Data(3,downind)= Data(3,downind) - spansig ;
                  w = 1./Data(3,:).^2;
              end

%             Compute RMS scatter of residuals (using all data)
              numdata = length(res); 
              chisqr = (res.^2*w');
              if numdata > np 
                 nrms = sqrt(chisqr/(numdata-np));
                 wrms = sqrt((numdata/(numdata-np))*chisqr/sumw);
              else
                 nrms = 1;
                 wrms = sqrt(1/sumw);
              end
              cov = inv(neq)*nrms^2 ;

%             Look for outliers
              edtime = [];
              if ~isempty(outliercut)
                for i = 1:length(Data(1,:))
                    if abs(res(i)/(Data(3,i)*nrms)) > outliercut 
                      edtime = [edtime, Data(1,i)];
                      if ReportEdits  
                          fprintf(1,'Edit %6d Date %4d %2d %2d %2d %2d Res %6.1f +- %6.1f %s\n', ...
                             i,YrToDate(Data(1,i),5), res(i), Data(3,i), CompName(k,:)) 
                      end
                    end
                end
              end
       
              if  ~isempty(edtime) > 0 
                  edtime = unique(edtime);
                  for j = 1:length(edtime)
                      if k == 1 
                         for i = 1:length(DataN(1,:))
                            if edtime(j) == DataN(1,i),  edits = [edits, i]; end
                         end
                     elseif k == 2 
                          for i = 1:length(DataE(1,:))
                            if edtime(j) == DataE(1,i),  edits = [edits, i]; end
                         end
                     elseif k == 3 
                         for i = 1:length(DataU(1,:))
                            if edtime(j) == DataU(1,i),  edits = [edits, i]; end
                         end
                     end    
                  end
                  edits = unique(edits);
                  if cnt > 30 , iter = 0;  end
              else
                  iter = 0;
              end     % while iter == 1 loop
           end
           
           for i = 1:length(edits)
               if  isempty(edit_code) || ~any(edit_code(:,1) == edits(i))
                 edit_code = [edit_code; edits(i) 4];
               end
           end
%           tmp3 = edit_code
                   
           %
           % If realistic errors are requested, use the residuals to now
           % compute
           if RealSigma 
               % fprintf(1,'Computing Realistic Sigmas\n');
               Comptext = CompName(k,:);
               PlotTitle = sprintf('RealSigma %s %s',strrep(name,'_','\_'),Comptext);
               [nrmsR, tauf(k), dchi(k)]  = CalcRealSigma(Data,res,PlotTitle);            
               % Scale the covariance matrix by the new nrms
               cov = cov*(nrmsR/nrms)^2;
               nrms = nrmsR;
           end
           % Finished iterating on solution
           % Now generate resiudal for ploting
           soln_res = soln; soln_mod = soln;
           % If we are only going to show linear only residuals, set the
           % non-linear terms to zero
           for i = 1:length(ores)
               if ~ores(i), soln_res(i) = 0; 
               else soln_mod(i) = 0;
               end
           end
           % Compute the residuals with only specific terms included
           if lores, 
               res = (Data(2,:) - (a*soln_res)'); 
               res = res - mean(res);
               ymtm = zeros(1,length(Data(1,:)));
               for i = 1:length(Data(1,:))
                  pm = GenPar(Data(1,i),meanT, np, anpar,sapar,exprt,breaks);
                  ymtm(i) = pm*soln_mod;
               end
               % get mean offset from data
               mof = mean(ymtm - res);
           end
           

           [hp,CData] = gpsplot(h(k),Data,res,[],sym, sigmacut,outliercut,0,k);
           if spandetrend
               yrange = ylim; 
               plot([xrange(1) xrange(1) NaN xrange(2) xrange(2)], ...
                   [yrange(1) yrange(2) NaN yrange(1) yrange(2)],'k','linewidth',1);
           end
           set(h(k),'Tag',strcat('Axis',num2str(k,'%1d')));
           if k == 1
               set(hp,'Tag','PlottedDataN');
               set(h(1),'UserData',{DataN,symN});
               nClnData = CData;
               nRes = res;
           elseif k == 2
               set(hp,'Tag','PlottedDataE');
               set(h(2),'UserData',{DataE,symE});
               eClnData = CData;
               eRes = res;
           elseif k == 3
               set(hp,'Tag','PlottedDataU');
               set(h(3),'UserData',{DataU,symU});
               uClnData = CData;
               uRes = res;
           end
           
           % Link the axes for zooms
           linkaxes(h,'x');
           
           % Generate the model and model error bars
           range = axis;
           nmod = fix((range(2)-range(1))*365);
           xmod = [range(1):(range(2)-range(1))/nmod:range(2)]; ymod=zeros(1,nmod);
           if lores && np > 2     
                for i = 1:length(xmod)
                    pm = GenPar(xmod(i),meanT, np, anpar,sapar,exprt,breaks);
                    ymod(i) = pm*soln_mod;
                end
                % ymod = ymod - mean(ymod);
                ymod = ymod - mof;
                plot(xmod,ymod,'Color',[0.2 0.2 0.2],'LineWidth',2);
           else
               ymod = zeros(1,length(xmod));
           end
           
           % Generate the errors in the times
           cove = cov; cove(1,:) = 0; cove(:,1) = 0;
           for i = 1:np; if( cove(i,i) > 300 ) cove(i,i) = 0.0; end ; end
           yerrp = zeros(1,length(xmod)); yerrm = zeros(1,length(xmod));
           for i = 1:length(xmod)
               pm = GenPar(xmod(i),meanT, np, anpar,sapar,exprt,breaks);
               sigm = sqrt(pm*cove*pm');
               yerrp(i) = ymod(i)+sigm; yerrm(i) = ymod(i)-sigm;
           end
           plot(xmod,yerrp,'Color',[255 18 22]/255,'LineWidth',1);
           plot(xmod,yerrm,'Color',[255 18 22]/255,'LineWidth',1);
           
           
           Comptext = CompName(k,:);
           PlotTitle = sprintf('Data %s %s',pname,Comptext);

           title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
         

%          Add statistics to plot
           xsize = xlim;
           ysize = ylim;

%          Add the 0 line and 3 sigma lines to the plot
           line(xsize,[0 0]','Color','b','LineWidth',1);
           line(xsize,[wrms*3 wrms*3],'Color','g','LineWidth',1);
           line(xsize,[wrms*-3 wrms*-3]','Color','g','LineWidth',1);
       
%          Write out the solution 
%           fprintf(1,'Detrend of %s %s WRMS scatter %8.2f mm NRMS %6.2f from %5d data\n', ...
%                name, CompName(k,:), wrms, nrms, length(res));
           nd = length(res);
           name_txt = sprintf('Detrend of %s %s \n', ...
               pname, Comptext); 
           stat_txt = sprintf('WRMS: %7.2f mm NRMS:%6.2f #: %5d data', ...
               wrms, nrms, nd);
           mean_txt = [];
           if abs(soln(1)) < 1000 
                mean_txt = sprintf('Mean: %8.2f +- %6.2f mm    ',soln(1), sqrt(cov(1,1)));
           end
           rate_txt = sprintf('  Rate: %8.2f +- %6.2f mm/yr ',soln(2), sqrt(cov(2,2)));
           
           outall = strvcat(outall,EstResult(pname, Comptext, wrms, nrms, nd, ...
               anpar, sapar, exprt, breaks, soln, cov));
           
           % Save the values for later output with the SAVE command
           if isempty(Stot), Stot = [ 0 0 0] ; end
           Strend(k,1) = length(res);
           Strend(k,2) = Stot(k)+soln(1)/1000.; Strend(k,3) = sqrt(cov(1,1))/1000.;
           Strend(k,4) = std(Data(2,:)); Strend(k,5) = (nrms/wrms)*Strend(k,4);
           Strend(k,6) = soln(2);   Strend(k,7) = sqrt(cov(2,2));
           Strend(k,8) = wrms;      Strend(k,9) = nrms;
           Strend(k,10) = max(Data(1,:))-min(Data(1,:)); Strend(k,11) = mean(Data(1,:));

           outstr = [stat_txt rate_txt];
           % Only write the rate text to the Screen.  A new figure will pop
           % with all the results
 %          WriteText(xsize(1),ysize(2),outstr,[.7 .9 .7]);
           text(0.01,1.005,outstr, ...
                    'VerticalAlignment','bottom','Units','normalized')   %  , ...)
%           if ~ isempty(mean_txt) 
%                text(0.01,0.90,mean_txt, ...
%                   'VerticalAlignment','bottom','Units','normalized')   %  , ...)
%           end

                    %                  'BackgroundColor',[.7 .9 .7]);  % Add at 6.5
          fprintf(1,'%s\n',outall(k,:));
 %         fprintf(1,'%s\n',mean_txt);
  
        end
        
        % Now look at the size of the axes and set to "resonable values"
        % Get the scales of each of the plots
        nlim = get(h(1),'Ylim');
        elim = get(h(2),'Ylim');
        alim = [min([nlim elim]) max([nlim elim])];
        dl = alim(2)-alim(1);
        if dl < 15, dlm = 1; 
        elseif dl < 50 ,dlm = 5;
        else dlm = 20;
        end
        alim = alim-mod(alim,dlm)+(1+sign(alim))*dlm/2;
        set(h(1),'Ylim',alim); set(h(2),'Ylim',alim);
        
%       Show where the breaks are on the plot
        if ~isempty(breaks), lbrk = length(breaks(:,1)); else lbrk = 0; end

        for i = 1:3      % loop over the three axes
           axes(h(i));
           for k = 1:lbrk
               x = breaks(k,1); te = breaks(k,2);
               if te == 0 && breaks(k,6) == 0
                   if break_code(k) == 4
                       plot([x x],ylim,'m');
                   else
                     plot([x x],ylim,'g');
                   end
               elseif te == 0 && breaks(k,6) == 3  
                   plot([x x],ylim,'k');
               elseif te > x
                   plot([x x],ylim,'b'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x te],[yb yb],'b','LineWidth',2);
               else plot([x x],ylim,'r'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x x-te],[yb yb],'r','LineWidth',2);
               end
           end
        end
        
%       Loop over the three components
%       New figure as a text box (Pit in upper right hand corner
%       Set sizes based in character size.  Text is upto 60 characters and
%       3*(np+3) lines (np is number of parameters estimated).
        set(0,'Units','characters'); 
        scnsize = get(0,'ScreenSize');
        set(hf,'Units','characters');
        figsize = get(hf,'Position'); 
        cw = 70 ; % Number of characters wide that we need to allow for output.  
                    % Seems to vary between machines and releases.  61 is
                    % nominal width, but 70 needed for some releases.
        cw = floor(max([55 length(name_txt)+2])*1.3);
        if KF
            cw = floor(max([55 length(name_txt)+10])*1.3);
        end
%        pos = fix([scnsize(3)-400 scnsize(4)-(np+3)*35-30 360 (np+3)*35]);
        pos = [scnsize(3)-(cw+4) figsize(2)+figsize(4)-(np+3)*3.5 cw (np+3)*3.5+0.2];
        outall_save = outall;
         
        hr = figure('Units','characters', ...
                  'MenuBar','none', ...
                  'Position',pos, ...
                  'Tag','Result1');
% 	            'Position',[0 0 350 (np+3)*35], ...              
       hk = uicontrol('Parent',hr, ...
	            'Units','characters', ...
	            'Position',[0 0 cw (np+3)*3.5], ...
                'BackgroundColor',[1 1 0.78], ...
	            'String',outall, ...
                'FontName','Monospaced', ...
                'HorizontalAlignment','left', ...
	            'Style','text', ...
	            'Tag','OutResult1');
        set(0,'Units','pixels');
        set(hf,'Units','pixels');

       %
       % Spectral Analysis MM & CW
       %
        if Spectral
          %      Loop over each component
          figure
            set(gcf,'position',[500 100 1000 600]);
            % Prepare some plotting on draconitic and solar period harmonics
	        anual = [ 8*365.25; 4*365.25; 2*365.25; 365.25; 365.25/2; 365.25/3; 365.25/4; 365.25/5; 365.25/6; 365.25/7; 365.25/8; 13.66];
            draconitic = [ 351.4; 351.4/2; 351.4/3; 351.4/4; 351.4/5; 351.4/6; 351.4/7; 351.4/8 ];
            site = pname(1:4);

          for k = 1:3
            if k == 1,     Data = nClnData;res = nRes;% DataN; sym = symN;
            elseif k == 2, Data = eClnData;res = eRes;% DataE; sym = symE;
            elseif k == 3, Data = uClnData;res = uRes;% DataU; sym = symU;
            end

            Data(1,:) = (Data(1,:)*365.25); 
            [power,f,alpha,sig95] = fastlomb(res,Data(1,:));
            
            if(k == 1) 
              ha(k) = subplot(311); 
              site_title = sprintf('%s - %s',pname,'Amplitude vs Period - North');
            elseif(k == 2) 
              ha(k) = subplot(312); 
              site_title = sprintf('%s - %s',site,'Amplitude vs Period - East');
            elseif(k == 3) 
              ha(k) = subplot(313); 
              site_title = sprintf('%s - %s',site,'Amplitude vs Period - Up');
            end

            %plot(1./f,power,'b'); hold on;
            %
            % Plot the amplitude
            %
            plot(1./f,2*sqrt(power/length(Data(1,:))),'b'); hold on;
            % MOD TAH 130115: Set scale based on length of data
            dur = Data(1,end)-Data(1,1);  % Duration in days
            if dur > 10*365 
                maxx = 10.5*365.25;
                xtick = [5 10 30 91 182 365 730 1460 2920];
            elseif dur > 4*365
                maxx = 4.2*365.25;
                xtick = [4 5 10 30 91 182 365 730 1460];
            else
                maxx = 500;
                xtick = [4 5 10 30 91 182 365];
            end
            set(gca,'xdir','reverse','xscale','log','xlim',[3 maxx],'xtick',xtick);%,'yscale','log');
            ylimit = get(gca,'ylim');

            plot([anual anual],[ylimit(1) ylimit(2)],'g-');
            plot([draconitic draconitic],[ylimit(1) ylimit(2)],'r-');

            ylabel('Amplitude (mm)');
            %xlabel('Period (days)');
            title(site_title,'fontweight','bold', ...
                'Interpreter','none')
            ylimit = [];
            %ClnData = [];
          end 
          %
          % Link all of the x-axis together so it is possible to do a collective zoom
          %
          linkaxes(ha,'x');
        end
        
        % Now see if Kalman filter estimate requested
        outall = []; min_rw = 0.05;
        if KF
           
            % Run the kalman filter estimate. 
            fprintf('......................................................\n');
            RW = zeros(3,1);
            for k = 1:3
               if k == 1,     Data = DataN; sym = symN;
               elseif k == 2, Data = DataE; sym = symE;
               elseif k == 3, Data = DataU; sym = symU;
               end
 %             Data = get(gcbf,'UserData');
               eds = ones(1,length(Data(1,:)));
               eds = logical(eds);
               for i = 1:length(edits)
                   eds(edits(i)) = 0;
               end
          
               Data = Data(:,eds); sym = sym(:,eds);
          
               % Get the process noise value: velocity sigma*Duration.
               % This setting is consistent with default tsfit.
               RW(k) = (Strend(k,7)^2)*Strend(k,10)+min_rw;  % mm^/yr
               % See if values overwritten by options
               if ~isempty(kfopts{3}) 
                   RW(k) = RWu(k);
               end
               if ~isempty(kfopts{4})
                   tauf(k) = taufu(k);
               end
               % White noise model has no process noise and should match
               % WLS solution (check)
               if strcmp(kftype,'WN') , RW(k) = 0.0 ; end
               
               fprintf('Kalman Filter %s comp %s, RW %6.3f mm^2/yr  Duration %8.3f yrs\n', ...
                  kftype, CompName(k,:),RW(k), Strend(k,10));
               %  Initialize the parameter covariance matrix
               cov = diag(ones(np+1,1)*1.e4) ; % 100^2 mm^2 apriori variance
               cov(np+1,np+1) = RW(k)/(2*tauf(k)/365.25); 
               fprintf('FOGM Sigma %6.2f mm, Tau %6.1f days dChi %6.2f\n', ...
                   sqrt(cov(np+1,np+1)),tauf(k), dchi(k));
               sol = zeros(np+1,1) ;  % Initialize the solution
               prechi = 0;
%              Start up incremental kalman filter
               ndat = length(Data(1,:));
               for i = 1:ndat
                   pb = GenPar(Data(1,i),meanT, np, anpar,sapar,exprt,breaks);
                   p = [pb 1]; % Set the velocity partial = 0
                   S = eye(np+1); 
                   if i > 1 
                       dt = Data(1,i)-Data(1,i-1);
                   else
                       dt = 0;
                   end
                   S = eye(np+1); 
                   % This code implemtents FOGM process consistent with the
                   % FOGMEX estimates of the correlation times (FOGM option
                   % in tsfit)
                   if strcmp(kftype,'FOGM') 
                        S(np+1,np+1)=exp(-dt/tauf(k)); 
                   end
                   % Propagate state
                   sol = S*sol ;
                   cov = S*cov*S'; cov(np+1,np+1) = cov(np+1,np+1)+RW(k)*dt;
                   if DispStoch
                       % RTS filter will be run so save Update step
                       % solution and covariane matrix
                       solm_save(:,i) = sol;
                       covm_save(:,:,i) = cov;
                   end

                   covm = (p*cov*p'+Data(3,i)^2);
                   % This code would scale data error bars consistent wihth
                   % FOGMEX estimate.  Not done in tsfit.
                   % covm = (p*cov*p'+Data(3,i)^2*dchi(k));
                   K = cov*p'/covm;
                   prechi = prechi + (Data(2,i)-p*sol)^2/covm;
                   sol = sol + K*(Data(2,i)-p*sol);
                   cov = cov - K*p*cov;
                   if DispStoch
                       solp_save(:,i) = sol;
                       covp_save(:,:,i) = cov;
                   end
                       

                   
               end
               
               % See if we will run the RTS smoother
               if DispStoch
                   solf = sol ; covf = cov ;
                   efog(ndat,k) = sol(np+1); sfog(ndat,k)=sqrt(cov(np+1,np+1));
                   for i = ndat-1:-1:1
                       dt = Data(1,i+1)-Data(1,i);
                       if strcmp(kftype,'FOGM') , S(np+1,np+1)=exp(-dt/tauf(k)); end

                       Lt = covp_save(:,:,i)*S'*inv(covm_save(:,:,i+1));
                       solf = solp_save(:,i)+Lt*(solf-solm_save(:,i+1));
                       covf = covp_save(:,:,i) + Lt*(covf-covm_save(:,:,i+1))*Lt';
                       efog(i,k) = solf(np+1) ; sfog(i,k)=sqrt(covf(np+1,np+1));
                   end
                   % Now compute residuals 
                   res = (Data(2,:)' - a*sol(1:np)-efog(:,k));
                   if DispRes
                       if k == 1 
                           % Create new figure
                           hs = zeros(3,1);
                           hkfr = figure('Position',[120 200 1000 600]); 
                           subplot(3,1,1);

                       else
                           figure(hkfr);
                           subplot(3,1,k);
                       end

                       % [hp,CData] = gpsplot(gca,Data,res,[],sym, sigmacut,outliercut,0,k);
                       ylmx = max(res)+0.5e-3; ylmn = min(res)-0.5e-3;
                       ylms = [ylmn-(ylmx-ylmn)*0.05 ylmx+(ylmx-ylmn)*0.05];
                       %hp = plot(Data(1,:),ydat-mean(ydat),'bs','MarkerSize',4); % Save the graphics handle
                       he = errorbar(Data(1,:),res,Data(3,:),'.','Color',[0.75 0.75 0.75]) ; hold on;
                       plot(Data(1,:),res,'bo','MarkerSize',4,'MarkerFaceColor',[0 0.1 1]);
                       ylabel([CompName(k,:) ' Res (mm)']);
                       hs(k) = gca; 
                       if k == 1
                           ht = title([pname ' KF Position residuals ' kftype]);
                           set(ht,'interpreter','none');
                       end
                       axis tight ; 
                       ylim( ylms ) ;
                       hold off
                   end
                   
                   chisqr = (res'.^2*w');
                   if numdata > np 
                       nrms = sqrt(chisqr/(numdata-np));
                       wrms = sqrt((numdata/(numdata-np))*chisqr/sumw);
                   else
                       nrms = 1;
                       wrms = sqrt(1/sumw);
                   end
               else
                   % Recover the WLS WRMS
                   wrms = Strend(k,8);                 
               end
               
               % Done with forward solution
               fprintf('Prefit ChiSquared %10.2f for %d data \n',prechi/ndat, ndat);
               % fprintf('NP %d Value %8.2f +- %8.2f\n',[(1:np+1) ; sol' ; diag(cov).^0.5']);
               
               Comptext = [CompName(k,:) ' Kalman Filter ' kftype];
               nrms = sqrt(prechi/ndat); nd = ndat; 
               name_txt = sprintf('%s %s \n', ...
                  pname, Comptext); 
               stat_txt = sprintf('WRMS: %7.2f mm PreFit Chi %6.2f #: %5d data', ...
                  wrms, nrms, nd);
               mean_txt = sprintf('Mean: %8.2f +- %6.2f mm    ',sol(1), sqrt(cov(1,1)));
               rate_txt = sprintf('Rate: %8.2f +- %6.2f mm/yr ',sol(2), sqrt(cov(2,2)));

               % if ~isempty(outall) , fprintf('%s\n',outall(k,:)); end
               % wrms = Strend(k,8) ; % Get the value from the WLS fit.
               outall = strvcat(outall,EstResult(pname, Comptext, wrms, nrms, nd, ...
                  anpar, sapar, exprt, breaks, sol, cov));
           
               % Save the values for later output with the SAVE command
               if isempty(Stot), Stot = [ 0 0 0] ; end
               Strend(k,1) = length(res);
               Strend(k,2) = Stot(k)+soln(1)/1000.; Strend(k,3) = sqrt(cov(1,1))/1000.;
               Strend(k,4) = std(Data(2,:)); Strend(k,5) = (nrms/wrms)*Strend(k,4);
               Strend(k,6) = soln(2);   Strend(k,7) = sqrt(cov(2,2));
               Strend(k,8) = wrms;      Strend(k,9) = nrms;
               Strend(k,10) = max(Data(1,:))-min(Data(1,:)); Strend(k,11) = mean(Data(1,:));
               % fprintf('PN end  %8.2f +- %6.2f mm\n',sol(np+1), sqrt(cov(np+1,np+1)));

               fprintf('%s\n',outall(k,:));
            end
            if DispRes , linkaxes(hs,'x'); end
           
            % Output text figure with the estimates.
            set(0,'Units','characters'); 
            pos = [scnsize(3)-(cw+4) figsize(2)+figsize(4)-2*(np+3)*3.5-2 cw (np+3)*3.5+0.2];
            outall_save = outall;
         
            hr = figure('Units','characters', ...
                  'MenuBar','none', ...
                  'Position',pos, ...
                  'Tag','Result1');
            hk = uicontrol('Parent',hr, ...
	            'Units','characters', ...
	            'Position',[0 0 cw (np+3)*3.5], ...
                'BackgroundColor',[1 0.90 0.68], ...
	            'String',outall, ...
                'FontName','Monospaced', ...
                'HorizontalAlignment','left', ...
	            'Style','text', ...
	            'Tag','OutResult1');
            set(0,'Units','pixels');
 
            if DispStoch
                % Plot up the process noise estimates.
                hr = figure('Position',[100 100 1000 600]); 
                
                N = floor(ndat/25);
                for i = 1:3
                   subplot(3,1,i);
                   plot(Data(1,:),efog(:,i),'b') ; hold on; 
                   errorbar(Data(1,1:N:end),efog(1:N:end,i),sfog(1:N:end,i),'ko', ...
                        'MarkerFaceColor',[0.8 0.8 0.8],'MarkerEdgeColor',[0.8 0.8 0.8]);
                   ylabel(['FOGM ' CompName(i,:) ' (mm)']); axis tight;
                   ylim([min(efog(:,i))*1.05 max(efog(:,i))*1.05]);
                   if i == 1 
                       ht = title([pname ' KF Process noise ' kftype]);
                       set(ht,'interpreter','none');
                   end
                   hold off;
                end
                
            end
            
        end  
        
                
    case 'Span'
        %%
        zoom off;        % Turn off zoom in case it is on
        %breakhndl = findobj(gcbf, 'Tag','Pushbutton5');    
        %breaks = get(breakhndl,'UserData');
%        breaks = checkbr(breaks);
        [breaks break_code] = checkbr(breaks, break_code);

%       Wait until user presses the mouse button
        k = waitforbuttonpress;
        point1 = get(gca,'CurrentPoint');    % button down detected
        finalRect = rbbox;                   % return Figure units
        point2 = get(gca,'CurrentPoint');    % button up detected
        point1 = point1(1,1:2);              % extract x and y
        point2 = point2(1,1:2);
        p1 = min(point1,point2);             % calculate locations
        offset = abs(point1-point2);        % and dimensions
        for k = 1:3
            gn = get(h(k),'UserData'); Data = gn{1}; sym=gn{2};
            axes(h(k));

            eds = ones(1,length(Data(1,:)));
            eds = logical(eds);
            for i = 1:length(edits)
               eds(edits(i)) = 0;
            end
            Data = Data(:,eds); sym = sym(:,eds);

            l = 0 ;
            for i = 1:length(Data(1,:))
               if Data(1,i) > point1(1) && Data(1,i) < point2(1)
%                 We found point that needs to be plotted
                  l = l+1 ;
                  data_span(1:3,l) = Data(1:3,i) ; sym_span(l) = sym(i);
               end
            end
           
            hp = gpsplot(h(k),data_span,[],[],sym_span,sigmacut,outliercut,0,k);
            if k == 1, set(hp,'Tag','PlottedDataN');
            elseif k == 2, set(hp,'Tag','PlottedDataE');
            elseif k ==3, set(hp,'Tag','PlottedDataU'); end

            % ylabel('Position (mm)'); 
            Comptext = CompName(k,:);
            PlotTitle = sprintf('Data %s %s',pname,Comptext);
            title(PlotTitle,'Units','normalized', ...
                  'Position',[0.99 1.01 0],'FontWeight','bold', ...
                  'HorizontalAlignment','right','Interpreter','none');
            set(gca,'Tag',strcat('Axis',num2str(k,'%1d')));
%           Show where the breaks are on the plot
            if isempty(breaks), lbrk = 0; else lbrk = length(breaks(:,1)); end  
            for j = 1:lbrk
               x = breaks(j,1); te = breaks(j,2);
               if te == 0 && breaks(j,6) == 0  
                   plot([x x],ylim,'g');
               elseif te == 0 && breaks(j,6) == 3  
                   plot([x x],ylim,'k');
               elseif te > x
                   plot([x x],ylim,'b'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x te],[yb yb],'b','LineWidth',2);
               else plot([x x],ylim,'r'); 
                   ym = ylim; yb = ym(1)+(ym(2)-ym(1))*0.01;
                   plot([x x-te],[yb yb],'r','LineWidth',2);
               end
            end
        end
        
    case 'Save'
        % Get the names of files to be used
        he = findobj(gcf, 'Tag', 'EditFile');
        editfile = get(he,'String');
        hv = findobj(gcf, 'Tag', 'ENSFile');
        ensfile = get(hv,'String');
        hr = findobj(gcf, 'Tag', 'RtFile');
        DetailRoot = get(hr,'String');
        
        gn = get(h(1),'UserData'); Data = gn{1}; sym=gn{2}; 
        
        [status username] = system('whoami');
        datestamp = datestr(now, 31);
        
        if WriteEdFile 
           if EraseEdFile , [fid, message] = fopen(editfile,'w');
           else [fid, message] = fopen(editfile,'a'); end
           %[edfile_path,edfile_name,edfile_ext,edfile_versn] = fileparts(editfile);
           [edfile_path,edfile_name,edfile_ext] = fileparts(editfile);
           if fid == -1  
               disp(['Error opening ' editfile ' : ' message])
           end
        end
        
        if WriteEnFile
            if EraseEnFile , [fie, message] = fopen(ensfile,'w');
            else [fie, message] = fopen(ensfile,'a'); end
            if fie == -1
                disp(['Error opening ' ensfile ' : ' message])
            end
            % See of the file is empty
            if EraseEnFile
                % Write the headers to the file.
                h0 = 'TSVIEW: Generated Summary file';
                h1 = '  Stations   enu  S#   #   mean length   sig    wrms  nrms      slope     sig    wrms nrms   dur   mean';
                h2 = '                               (m)       (m)    (mm)           (mm/yr)  (mm/yr)  (mm)       (yrs)  (yrs)';
                fprintf(fie,'%s\n%s\n%s\n',h0,h1,h2);
            end
        end
        
        if WriteRtFile
            % Construct the file name
            detfile = strcat(DetailRoot,name,'.det');
            if EraseRtFile , [fir, message] = fopen(detfile,'w');
            else [fir, message] = fopen(detfile,'a'); end
            if fir == -1
                disp(['Error opening ' detfile ' : ' message])
            end
        end

        if WriteEdFile && fid > 0
            edits_sort = sort(edits);
            % tmp4 = edit_code;
            edit_code_sort = sortrows(edit_code);
            % Check length of name to see if .pos or mb_ file
            if length(name) == 8 
                nameout = name;
                [head,tail] = strtok(name,'_');
                rename = strrep(name,tail,'_XPS');
                cen = ' ';
            else
%                nameout = strcat(name(1:4),'_GPS');
                nameout = name(1:4);
                rename = strcat(name(1:4),'_XPS');
                cen = name(6:length(name));
                cen = ' ';
            end
            
            for i = 1:length(edits_sort)
%             get the fractional part of the year and convert to month and day
               bdate = YrToDate(Data(1,edits_sort(i)),3);
             
             
               if edit_code_sort(i,2) == 1
                  edit_comment = sprintf('! tsview edit block : Added by %s on %s',strtrim(username),datestamp);
               elseif  edit_code_sort(i,2) == 2 
                  edit_comment = sprintf('! edit : From file %s on %s',eqfile,datestamp);
               elseif  edit_code_sort(i,2) == 3
                  edit_comment = sprintf('! tsview edit > %d mm sigma : Added by %s on %s',sigmacut,strtrim(username),datestamp);
               elseif  edit_code_sort(i,2) == 4
                  edit_comment = sprintf('! tsview edit > %d sigma outlier : Added by %s on %s',outliercut,strtrim(username),datestamp);
               elseif  edit_code_sort(i,2) == 5
                  edit_comment = sprintf('! tsview edit : Added by %s on %s',strtrim(username),datestamp);
               else 
                  edit_comment = sprintf('! tsview edit unknown : Added by %s on %s',strtrim(username),datestamp);
               end             

%            fprintf(fid,' rename %s %s %s %4d %2d %2d 00 00 %4d %2d %2d 24 00  \n', ...
%               nameout,rename,cen, bdate(1:3),bdate(1:3));
               fprintf(fid,' rename %s %s %s %4d %2d %2d 00 00 %4d %2d %2d 24 00 %s \n', ...
               nameout,rename,cen, bdate(1:3),bdate(1:3), edit_comment);
            end

            if ~isempty(breaks)
                % Add break at end so that last will be open ended break
                % breakf = [breaks; 2100.0 1 1 0 0];  
%               breaks = [breaks;Data(1,length(Data))]; Wrong - requires data are in time order SCM
                [breaks_sort,sindx] = sort([breaks; 2100 0 0 0 0 0]);
                [head,tail] = strtok(nameout,'_');
                nbrk = size(breaks_sort,1);
                [status username] = system('whoami');
                datestamp = datestr(now, 31);
                for i = 1:nbrk-1  % There is an artifical ending break at 2100 1 1 0 0 
%                      get the fractional part of the year and convert to month and day
                    yrs = fix(breaks_sort(i));
                    yre = fix(breaks_sort(i+1));
                    fyrs = mod(breaks_sort(i),1);
                    fyre = mod(breaks_sort(i+1),1);
                    if mod(yrs,4) == 0 , doys = fyrs*366 + 1;
                    else doys = fyrs*365 + 1; end
                    if mod(yre,4) == 0 , doye = fyre*366 + 1;
                    else doye = fyre*365 + 1; end
                    sers = datenuml(yrs,1,doys);
                    sere = datenuml(yre,1,doye);
                    bdates = datevecl(sers);
                    bdatee = datevecl(sere);
                    
                    newtail = strcat('_',num2str(i,'%1d'),'PS');
                    rename = strcat(name(1:4),newtail);
                    if length(name) == 8
                        nameout = name;
                    else
                        nameout = strcat(name(1:4),'_GPS');
                    end
                    if mod(doys,1) > 0.5, bhours = [24 00];
                    else bhours = [00 00]; end
                    if mod(doye,1) > 0.5, bhoure = [24 00];
                    else bhoure = [00 00]; end
                   
                    if break_code(sindx(i)) == 1
                      break_comment = sprintf('! break : From file %s on %s',eqfile,datestamp);
                    elseif  break_code(sindx(i)) == 2 
                      break_comment = sprintf('! rename :From file %s on %s',eqfile,datestamp);
                    elseif  break_code(sindx(i)) == 3 
                      break_comment = sprintf('! EQ rename : From file %s on %s',eqfile,datestamp);
                    elseif  break_code(sindx(i)) == 4 
                      break_comment = sprintf('! tsview break : Added by %s on %s',strtrim(username),datestamp);
                    elseif  break_code(sindx(i)) == 5 
                      break_comment = sprintf('! tsview exp : Added by %s on %s',strtrim(username),datestamp);
                    elseif  break_code(sindx(i)) == 6
                      break_comment = sprintf('! tsview log : Added by %s on %s',strtrim(username),datestamp);
                    elseif  break_code(sindx(i)) == 7
                      break_comment = sprintf('! tsview append : Added by %s on %s',strtrim(username),datestamp);
                    else 
                      break_comment = sprintf('! tsview break : Added by %s on %s',strtrim(username),datestamp);
                    end
                    
%                   sprintf('edfile_ext %s',edfile_ext);
                    if strcmp(edfile_ext,'.brk')    
                      fprintf(fid,' break %s %4d %2d %2d %2d %2d %s \n', ...
                             name(1:4),bdates(1:3),bhours(1:2), break_comment);                     
                    else           
                      if i < nbrk-1
                           fprintf(fid,' rename %s %s %4d %2d %2d %2d %2d %4d %2d %2d %2d %2d %s \n', ...
                              nameout,rename,bdates(1:3),bhours(1:2),bdatee(1:3), bhoure(1:2), break_comment);
                      else
                           fprintf(fid,' rename %s %s %4d %2d %2d %2d %2d %s\n', ...
                               nameout,rename,bdates(1:3),bhours(1:2), break_comment);
                      end
                    end
                                                
                end     % Looping over the breaks
            end         % If there are breaks
            fclose(fid); 
        end             % If we are writing the edits files
       
        % Now write out the ensum file 
        if WriteEnFile && fie > 0
           compname = ['N' 'E' 'U'];
           for k = 1:3
              fprintf(fie,'%8s-       %s  1 %4d %13.4f %6.4f %5.1f %5.2f   %8.2f %8.2f %5.1f %5.2f %5.2f %7.2f\n', ...
                  name([1:8]),compname(k),Strend(k,:));
           end
           fclose(fie);
        end
        
        % See if we are wriing the Details file
        if WriteRtFile && fir > 0
            outall= outall_save ;
            fprintf(fir,'------- %4d/%2d/%2d %2d:%2d %2d -------\n',fix(clock));
            for k = 1:3
                fprintf(fir,'%s\n',outall(k,:));
            end    
            fclose(fir) ;
        end

       
   case('DeleteBreak')
       % Code to delete breaks
       hbhndl = findobj(gcbf,'Tag','DeleteBreak');
       db = get(hbhndl,'Value');
       if ~isempty(breaks)
           brklist = logical(ones(1,length(breaks(:,1)))); brklist(db) = 0;
           breaks = breaks(brklist,:);
       end

   case('Sort')
       % Code to read a site list from an ensum file and sort the site
       % names based on this
       [hd, hgf] = gcbo ;
       % See which button got us here
       sort_opt = get(hd,'String');
       he = findobj(hgf,'Tag','SrFile');
       ensfile = get(he,'String');
       % See if normalized or WRMS to be used
       he = findobj(hgf,'Tag','SrNormal');
       nrms_sort = get(he,'Value');
       if isempty(ensfile) && sort_opt ~= 'A'
           errordlg('No name given for Ensum file');
       else
           err = 0;
           if sort_opt ~= 'A' 
%               fprintf(1,'Sorting on %s from file %s\n',sort_opt,ensfile);
               [ensrms, ensnames, err] = ReadENFile(nrms_sort, ensfile);
           else
               ensrms = []; ensnames=[];
           end
               
           % Now merge the site names from ensum file with the list of 
           % sites allocating an RMS value for sorting to each in the 
           % original list
           if err == 0
               sites = SortEns(sort_opt,  ensrms, ensnames, sites);
               % Save the sorted list of sites back into the site name handle
               set(sitehndl,'String',sites);
               set(sitehndl,'UserData',sites);
           end
       end
       
    case 'HideErrb'
        % The error bars on each plot
        h1 = findobj(hf,'Tag','Axis1'); he = findobj(h1,'Tag','PlotRes'); set(he,'Visible','off') 
        h2 = findobj(hf,'Tag','Axis2'); he = findobj(h2,'Tag','PlotRes'); set(he,'Visible','off') 
        h3 = findobj(hf,'Tag','Axis3'); he = findobj(h3,'Tag','PlotRes'); set(he,'Visible','off') 
       
   case 'Print'
       % Print figure.  Read the options from the PrintOpt box
       ho = findobj(hf,'Tag','PrintOpts');
       propts = get(ho,'String');
       % Find the blanks in the string and break into separate sections
       kb = findstr(propts,' '); kb = [kb length(propts)+1];
       lkb = length(kb);
       str2=[]; str3=[];str4=[];str5=[];
       if lkb > 0, str1 = propts(1:kb(1)-1); end
       if lkb > 1, str2 = propts(kb(1)+1:kb(2)-1); end
       if lkb > 2, str3 = propts(kb(2)+1:kb(3)-1); end
       if lkb > 3, str4 = propts(kb(3)+1:kb(4)-1); end
       if lkb > 4, str5 = propts(kb(4)+1:kb(5)-1); end
       % print(hf,str1,str2,str3,str4,str5);
       fprintf('Saveas %s |%s|\n',str1,str2)
       saveas(hf,str2);
       
   case 'PageSetup'
       % Page setup 
       pagesetupdlg(hf)
       
   case 'Average'
       fprintf(1,'Averaging residuals in %6.1f day bins with boundaries %8.4f yr\n', ...
           AvgLength,AvgTime);
       % Work over the 3-sets of axes
       h1 = findobj(hf,'Tag','Axis1'); AvgRes(h1,AvgLength,AvgTime);      
       h2 = findobj(hf,'Tag','Axis2'); AvgRes(h2,AvgLength,AvgTime);
       h3 = findobj(hf,'Tag','Axis3'); AvgRes(h3,AvgLength,AvgTime);
       
    case 'ClrEqList'
        % MOD TAH 130115: Changed operation here; first clear will clear
        % file; if no file namme then EQ's will be cleared
        hn = findobj(hf,'Tag','EqFile');
        eqfile = get(hn, 'String');
        if isempty(eqfile) 
            % No name in box, so clear eq lists
            neq = 0; nrn = 0;
            if ~isempty(eqeq) 
                seq_code = eqeq.EQ_CODE; neq = size(seq_code,1);
            end
            if ~isempty(eqrn)               
                srn_n1 = eqrn.RN_N1; nrn = size(srn_n1,1);
            end
            fprintf('Clearing existing %d earthquakes and %d renames\n',neq, nrn);
            eqeq = []; eqrn = [];
            saveeq = struct('EqRn',eqrn,'EqEq',eqeq);
            hu = findobj(hf,'Tag','EqFileHead');
            set(hu,'UserData',saveeq);

        else
            % File name in box so just clear the name (for easy typing)
            fprintf('Clearing Eq-file name only\n');
            set(hn,'String',[]);
        end
                     
    case 'LoadEqList'
        % Load the EQList information
        hn = findobj(hf,'Tag','EqFile');
        eqfile = get(hn,'String');
        [fid, message] = fopen(eqfile,'r');
        if fid == -1
            disp(['Error opening EQ file ' eqfile ' : ' message])
            errordlg(['Error opening EQ file ' eqfile ' : ' message])
            % eqeq = [] ; eqrn = []; % DO not clear
            return
        else
            [eqeq eqrn] = ReadEq(fid,eqfile, eqeq, eqrn);
            fclose(fid);             
        end
        
    case 'KFOpt'
        % Set up dialog box so that Kalman filter options can be set
        defs = get(gcbo,'UserData');
        dlg_title = 'Kalman Filter Setup';
        prompt = {'Type (RW/FOGM/WN)','Min RW','RW (mm^2/yr)','Tau (days)','Plot FOGM','Plot Residuals'};
        answer  = inputdlg(prompt,dlg_title,1,defs,'on');
        % Save the results back
        if ~isempty(answer) , set(gcbo,'UserData',answer); end
    
   end  % End of Case statements
   
% End of main GUI interface

% Update the Break GUI box
UpdateBreakGUI(hbhndl, breaks)

drawnow;

% Save back the persistent values
savecom = struct('Udir',udir,'Breaks',breaks,'Edits',edits, ...
    'Strend',Strend,'Stot',Stot,'Outall_save',outall_save, ...
    'Symnum',symnum,'PName',pname, ...
    'Break_code',break_code,'Edit_code',edit_code,'EqFile',eqfile);
    
set(hf,'UserData',savecom);


function breaks = Initbe
% INITBE Initialized the breaks and edit arrays
%
% Set the breaks to a null array, and save call back
clear breaks
breaks = [];
%breakhndl = findobj(gcbf, 'Tag','Pushbutton5');    
%set(breakhndl,'UserData',breaks);
%

function break_code = Initbrkcod
% Set the break codes to a null array, and save call back
clear break_code
break_code = [];

function edits = Initedits
% Initialize and save the edits
clear edits
edits = [];
%edithndl = findobj(gcbf, 'Tag','Pushbutton4');    
%set(edithndl,'UserData',edits);

function edit_code = Initedtcod
% Initialize and save the edit codes
clear edit_code
edit_code = [];
%edithndl = findobj(gcbf, 'Tag','Pushbutton4');    
%set(edithndl,'UserData',edits);



                
 

