function veln = AppOffAlign(offs, aligns, nf, veli)
% Function to return velocity estimates with offs applied for nf=1 (primary
% field) and offs+aligns for nf=2 (secondary field).
% offs(7) == 0 and aligns(7) == 0 if not rates at all (check before calling
% to save time).
veln = veli;

% Apply Offset first;
% See what options. Turn on all, the see what is not set.
np = 6; et = 1; er = 1; 
% If the rotation rates are zero then on 3 parameters
if offs(4:6)*offs(4:6)' == 0 , np = 3 ; er = 0; end
if offs(7) == 1 , et = 0 ; end

for k = 1:length(veli(1,:))
    clh = [pi/2-veli(2,k)*pi/180 veli(1,k)*pi/180 0]; 
    xyz = geod_to_xyz( clh ); 
    rot_mat = RotXYZ_to_NEU( clh ); 
    neu_part = GenPart( xyz, rot_mat, np, er, et);
    % Order of variables : dvel = [veli(4,k) ; veli(3,k) ; veli(10,k) ] ; % vNEU
    dvel= neu_part*offs(1:np)' ;
    veln(4,k)  = veli(4,k)  - dvel(1);
    veln(3,k)  = veli(3,k)  - dvel(2);
    veln(10,k) = veli(10,k) - dvel(3);
end

% If this if field 2, then also apply aligns
if nf == 2 && aligns(1:6)*aligns(1:6)' > 0 
    % See what options. Turn on all, the see what is not set.
    np = 6; et = 1; er = 1; 
    % If the rotation rates are zero then on 3 parameters
    if aligns(4:6)*aligns(4:6)' == 0 , np = 3 ; er = 0; end
    if aligns(7) == 1 , et = 0 ; end

    for k = 1:length(veli(1,:))
        clh = [pi/2-veli(2,k)*pi/180 veli(1,k)*pi/180 0]; 
        xyz = geod_to_xyz( clh ); 
        rot_mat = RotXYZ_to_NEU( clh ); 
        neu_part = GenPart( xyz, rot_mat, np, er, et);
        % Order of variables : dvel = [veli(4,k) ; veli(3,k) ; veli(10,k) ] ; % vNEU
        dvel= neu_part*aligns(1:np)' ;
        veln(4,k)  = veln(4,k)  - dvel(1);
        veln(3,k)  = veln(3,k)  - dvel(2);
        veln(10,k) = veln(10,k) - dvel(3);
    end
end

end

