function [lx,ly] = HghErrorBar(vels, scaleV, arrowstr,velinf)
% [lx,ly] = HghErrorBar(vels, scaleV, arrowstr,velinf): Generates line
% for vertical error bar.

% Use the arrowstr to tell how far off the line we need to go
conradV = sqrt(2)*erfinv(velinf.ConfidV/100);

if arrowstr.ArrHead == 1
    lx = [vels(1) vels(1)];
    ly = [vels(2)+vels(10)*scaleV(2)-vels(12)*scaleV(2)*conradV ...
          vels(2)+vels(10)*scaleV(2)+vels(12)*scaleV(2)*conradV];
else % Need to generate with a head
    [dn, de] = GenArrowHead(arrowstr.ArrHead); 
    arrowv = velinf.ArrowV; dn = dn/arrowv*scaleV(1);
    lx = [vels(1)-dn vels(1)+dn vels(1) vels(1) vels(1)+dn vels(1)-dn];
    ly = [vels(2)+vels(10)*scaleV(2)-vels(12)*scaleV(2)*conradV ...
          vels(2)+vels(10)*scaleV(2)-vels(12)*scaleV(2)*conradV ...
          vels(2)+vels(10)*scaleV(2)-vels(12)*scaleV(2)*conradV ...
          vels(2)+vels(10)*scaleV(2)+vels(12)*scaleV(2)*conradV ...
          vels(2)+vels(10)*scaleV(2)+vels(12)*scaleV(2)*conradV ...
          vels(2)+vels(10)*scaleV(2)+vels(12)*scaleV(2)*conradV];
end
