function ReportNum(vel1,vel2)
% Counts and reports numbers of stations on current plot

% Get the limits of the current axes
lims = [get(gca,'Xlim') get(gca,'Ylim')];
% Set up polygon
axx = [lims(1) lims(2) lims(2) lims(1) lims(1)];
axy = [lims(3) lims(3) lims(4) lims(4) lims(3)];
if ~isempty(vel1) 
    sitx = vel1(1,:); sity = vel1(2,:);
    in1 = inpolygon(sitx, sity, axx, axy);
    num1 = sum(in1);
else num1 = 0; end
if nargin == 2 & ~isempty(vel2)
    sitx = vel2(1,:); sity = vel2(2,:);
    in2 = inpolygon(sitx, sity, axx, axy);
    num2 = sum(in2);
    str = sprintf('Displaying Field 1 %d Sites; Field 2 %d Sites',num1,num2);
else
    str = sprintf('Displaying %d Sites',num1);
end
ht = findobj(gcf,'Tag','NumSite');
if ~isempty(ht), delete(ht); end

text('Position',[1.0 1.0 0.0],'Units','normalized', ...
    'VerticalAlignment','bottom', 'HorizontalAlignment','right', ...
    'String',str,'Tag','NumSite');

