function rot_mat = RotXYZ_to_NEU( clh )
% Create Rotation from XYZ to NEU based on geodetic coordinates

%       rot_mat(1,1) = -cos(loc_coord(1))*cos(loc_coord(2))
%       rot_mat(1,2) = -cos(loc_coord(1))*sin(loc_coord(2))
%       rot_mat(1,3) =  sin(loc_coord(1))
% c
% c
% c.... longitude -- east component
% c
%       rot_mat(2,1) = -sin(loc_coord(2))
%       rot_mat(2,2) =  cos(loc_coord(2))
%       rot_mat(2,3) =  0.d0
%
%       rot_mat(3,1) = cos(lat_i) * cos(long)
%       rot_mat(3,2) = cos(lat_i) * sin(long)
%       rot_mat(3,3) = sin(lat_i)
rot_mat = [ -cos(clh(1))*cos(clh(2)) -cos(clh(1))*sin(clh(2)) sin(clh(1)) ; ...
            -sin(clh(2))              cos(clh(2))             0.0         ; ...
             sin(clh(1))*cos(clh(2))  sin(clh(1))*sin(clh(2)) cos(clh(1)) ] ;
end