function [profll,hl,hb] = SelectProfile
% [profll,hl,hb] = SelectProfile : User selectable profile
%
% Since we have to the rrbox from screen coordinates, get some information
% about current figure and axes
%scnsize = get(0,'ScreenSize');
figsize = get(gcf,'Position');
axesize = get(gca,'Position');  % Could get CurrentAxes from gcf
llsize = [get(gca,'Xlim') get(gca,'Ylim')];
%asprat = get(gca,'DataAspectRatio');
% Based on the aspect ratio, find the actual coordinates coordinates
% covered by the axesize.
%ratio = (llsize(2)-llsize(1))*asprat(2)/(llsize(4)-llsize(3));
% MOD TAH 150120: Use the plotbox aspect ratio
das = get(gca,'plotboxaspectratio');
ratio = das(1)/das(2); 

if ratio > 1    % Longitude covers the full pixel range
    xoff = figsize(1)+axesize(1); xscl = (llsize(2)-llsize(1))/axesize(3); 
    % For Latitude, compute height of axes
    dyht = (axesize(4)-axesize(4)/ratio)/2;
    yoff = figsize(2)+axesize(2)+dyht; yscl=(llsize(4)-llsize(3))/(axesize(4)/ratio);
else
    dxwd = (axesize(3)-axesize(3)*ratio)/2;
    xoff = figsize(1)+axesize(1)+dxwd; xscl=(llsize(2)-llsize(1))/(axesize(3)*ratio); 
    yoff = figsize(2)+axesize(2); yscl=(llsize(4)-llsize(3))/axesize(4);
end
xin=llsize(1); yin=llsize(3);
% Construct the mapping array
%xoff = figsize(1)+axesize(1); yoff = figsize(2)+axesize(2);
%xscl = (llsize(2)-llsize(1))/axesize(3); yscl = (llsize(4)-llsize(3))/axesize(4);
%xin = llsize(1); yin = llsize(2);
pix2ll = [round(xoff) xscl xin ; round(yoff) yscl yin];
% display(figsize);
% display(axesize);
% display([das ratio])


% setup the figure button up function to see user data to 1
set(gcf,'WindowButtonUpFcn','buttonup');

% wait for button pres
figure(gcf);
waitforbuttonpress;
llint = GetLL(gcf,pix2ll);
hl = plot(llint([1 1]),llint([2 2]),'k+:');
set(gcf,'UserData',0);
done = 0;
while ~done 
    done = get(gcf,'UserData');
    llfin = GetLL(gcf,pix2ll);
    set(hl,'Xdata',[llint(1) llfin(1)]);
    set(hl,'Ydata',[llint(2) llfin(2)]);
    drawnow;
end
% Convert the line to a solid line and start on the box
set(hl,'LineStyle','-'); drawnow;
%
% Waitfor next button press
waitforbuttonpress;
pause(1);

box = [llint(1) llint(2); llint(1) llint(2); ...
        llfin(1) llfin(2); llfin(1) llfin(2); ...
        llint(1) llint(2)];
hb = plot(box(:,1),box(:,2),'k:');
set(gcf,'UserData',0);
done = 0;
while ~done 
    done = get(gcf,'UserData');
    lb = GetLL(gcf,pix2ll);
    box = MakeProfBox(llint,llfin,lb);
    %display(box)
    if ~isempty(box)
        set(hb,'Xdata',box(:,1));
        set(hb,'Ydata',box(:,2));
        drawnow;
    else
        fprintf('Empty box');
    end
end

profll = [llint; llfin; box];

