function VecGUISet(hf, SiteName, num,fld); 
% VecGUISet: Sets up the callback option in a plotted vector.
%
% Set the command string options:
Name = sprintf('%8s F%1d',SiteName,fld);
optstr = [ Name; ...
          ' LabelOnFig' ; ...  % 2
          ' LabelPopUp' ; ...  % 3
          ' TimeSeries' ; ...  % 4
          ' Delete    '];      % 5
  
% Get the current position of the pointer to poop up the menu
cpos = get(hf,'CurrentPoint');
pos = [cpos(1) cpos(2)+15 100 70];
fs = 10 ; % if strcmp(getenv('OSTYPE'),'linux') , fs = 9 ; end
  
% Generate the call back uicontrol
cb = sprintf('VecActions(%3d,%1d)',num,fld);
hl = uicontrol('Parent',hf, ...
	        'Units','pixels', ...
	        'Position',pos, ...
            'FontSize',fs, ...
	        'String',optstr, ...
            'BackgroundColor',[0.9 0.9 0.9], ...
	        'Style','listbox', ...
	        'Tag','Outlier', ...
            'CallBack',cb, ...
	        'TooltipString','Select outlier editing criteria', ...
	        'Value',1, ...
            'UserData', num); 
        