function stats = WMean(velinp,nameinp)
% stats = WMean(velinp): Compute mean and statistics of selected stations
% stats returns #site WMean_N Sig M WRMS_N NRMS_N WMean_E SigE WRMS_E
% NRMS_E Wmean_U SigU WRMS_U NRMS_U
%
% Find the wmean for each component
% stats = zeros(1,13);
% for i = 1:3
%     if i == 1, Vals = velinp(4,:); Sig = velinp(8,:);       % North
%     elseif i == 2, Vals = velinp(3,:); Sig = velinp(7,:);   % East
%     elseif i == 3, Vals = velinp(10,:); Sig = velinp(12,:); % Up
%     end
%     %
%     % Form the weight vector
%     num = length(Vals);
%     w = 1./Sig.^2;
%     Wmean = w*Vals'/sum(w);
%     r = Vals - Wmean;
%     if num > 1, nrms = sqrt(sum(r.^2.*w)/(num-1)); else nrms = 1; end
%     wrms = nrms*sqrt(num/sum(w));
%     stats(1) = num; stats(2+4*(i-1)) = Wmean; stats(3+4*(i-1)) = wrms/sqrt(num);
%     stats(4+4*(i-1)) = wrms; stats(5+4*(i-1)) = nrms;
% end
% Pause before continuing
[param, sigp, stats, res, sigd] = WEuler(velinp,nameinp);
hov = findobj(gcf,'Tag','Offvalue');
encodeparam(hov, param);
np = length(param);
% Not clear why pause; may have to do with graphics lag
% pause(2)
% Now output a new figure the results on it.
% Output parameter estimates and sigmas
ht = findobj(gcf,'Tag','EstTran'); hr = findobj(gcf,'Tag','EstRot');
et = get(ht,'Value'); er = get(hr,'Value');
vtext = sprintf('Offset Results from %d sites and %d param (click to remove)\n',stats(1),np);
vtext = [vtext  sprintf('Param        Est       +-   C  WRMS (mm/yr) NRMS\n')];

comps = ['dN mm/yr'; 'dE mm/yr'; 'dU mm/yr'; ...
         'dX mm/yr'; 'dX mm/yr'; 'dZ mm/yr'; ...
         'Wx rd/by'; 'Wy rd/by'; 'Wz rd/by'] ;
rmslb = 'NEU' ;
off = 0 ;
if et == 1 , off=3 ; end
if et == 0 && er == 1 , off = 6; end
for k = 1:3
    vtext = [ vtext, sprintf('%s %8.2f %8.2f  %c %8.2f  %8.2f\n', ...
        comps(off+k,:),param(k),sigp(k),rmslb(k),stats(2*(k-1)+[2 3]))];
end
for k = 4:np
    vtext = [ vtext, sprintf('%s %8.2f %8.2f  \n', comps(3+k,:),param(k),sigp(k))];
end    

vtext = [ vtext, sprintf('Site        NRes    +-    ERes    +-     URes    +-\n')];
for i = 1:length(res(1,:))
    vtext = [vtext, sprintf('%s %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f\n', ...
            nameinp(i,:), [res(:,i)' ; sigd(:,i)'])];
end
% Pause before continuing
pause(2);
% Get size of current axes
szfg = get(gcf,'Position');
pos = [szfg(3)-380 szfg(4)-(3+stats(1)+np)*13-3 380 (3+stats(1)+np)*13+3];
fs = 10 ; % if strcmp(getenv('OSTYPE'),'linux') , fs = 8 ; end
              
hk = uicontrol('Parent',gcf, ...
	       'Units','pixels', ...
	       'Position',pos, ...
           'BackgroundColor',[1 1 0.78], ...
	       'String',vtext, ...
           'FontSize',fs, ...
           'FontName','Monospaced', ...
           'HorizontalAlignment','left', ...
           'ButtonDownFcn','delete(gcbo)', ...
	       'Style','text', 'Enable','inactive',...
	       'Tag','OutResult2');
       
% Also output the results to the screen
fprintf(1,'--------------------------------------------------\n');
fprintf(1,'%s\n',vtext);

    
