function WriteSave(fid,hf)
% WriteSave(fid,hf) : Write data out to file

% Currently write primary files
hn = findobj(hf,'Tag','VelName1');
%save1 = struct('Vel',vel1,'Name',name1,'VellInf',vel1inf);
save1 = get(hn,'UserData');
%
% Get Original File name
origName = save1.VellInf.FileName;
fprintf(fid,'* VELVIEW Edited Velocity field based on %s\n',origName);
fprintf(fid,'* Long    Lat    dE/dt     dN/dt      DE/dt   dN/dt  SigE    SigN  Rho dH/dt  dH/dt SigH  Name\n');
num = length(save1.Vel(1,:));
for i = 1:num
    fprintf(fid,'  %7.3f %7.3f %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f %6.3f %6.2f %6.2f %6.2f %s\n', ...
        save1.Vel(:,i), save1.Name(i,:));
end

% See if there is a secondary field.  If so write out these results making
% any duplicate names comment lines.
hn = findobj(hf,'Tag','VelName2');
%save1 = struct('Vel',vel1,'Name',name1,'VellInf',vel1inf);
save2 = get(hn,'UserData');
%
% Get Original File name
if ~isempty(save2)
    origName = save2.VellInf.FileName;
    fprintf(fid,'* VELVIEW Edited Secondary Velocity field based on %s\n',origName);
    fprintf(fid,'* Sites in common with primary field appear as comments\n');
    fprintf(fid,'* Long    Lat    dE/dt     dN/dt      DE/dt   dN/dt  SigE    SigN  Rho dH/dt  dH/dt SigH  Name\n');
    num2 = length(save2.Vel(1,:));
    for i = 1:num2
        % See if this sites is common with the primary field.
        dup = 0;
        for j = 1:num
            if strcmp(save2.Name(i,:),save1.Name(j,:)), dup = 1; end
        end
        if dup
            fprintf(fid,'- %7.3f %7.3f %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f %6.3f %6.2f %6.2f %6.2f %s\n', ...
                save2.Vel(:,i), save2.Name(i,:));
        else
            fprintf(fid,'  %7.3f %7.3f %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f %6.3f %6.2f %6.2f %6.2f %s\n', ...
                save2.Vel(:,i), save2.Name(i,:));
        end
    end
end


fclose(fid);

